<?php
function shortcode_bootstrap_cdn($name = FALSE) {
  $lib_cdn = [
    'jquery-sortable' => 'https://cdnjs.cloudflare.com/ajax/libs/jquery-sortable/0.9.13/jquery-sortable-min.js',
    'jquery-easing' => 'https://cdnjs.cloudflare.com/ajax/libs/jquery-easing/1.4.1/jquery.easing.min.js',
    'jquery.appear' => 'https://cdnjs.cloudflare.com/ajax/libs/jquery.appear/0.4.1/jquery.appear.min.js',
    'raphael' => 'https://cdnjs.cloudflare.com/ajax/libs/raphael/2.2.8/raphael.min.js',
    'jQuery-Knob' => 'https://cdnjs.cloudflare.com/ajax/libs/jQuery-Knob/1.2.13/jquery.knob.min.js',
    'parallax' => 'https://cdn.jsdelivr.net/parallax.js/1.4.2/parallax.min.js',
    'pixastic' => 'https://cdn.jsdelivr.net/pixastic/0.1.3/pixastic.all.js',
    'jquery.mb.YTPlayer' => [
      'js' => 'https://cdnjs.cloudflare.com/ajax/libs/jquery.mb.YTPlayer/3.2.10/jquery.mb.YTPlayer.min.js',
      'css' => 'https://cdnjs.cloudflare.com/ajax/libs/jquery.mb.YTPlayer/3.2.10/css/jquery.mb.YTPlayer.min.css',
    ],
    'bootstrap-table' => [
      'js' => 'https://cdnjs.cloudflare.com/ajax/libs/bootstrap-table/1.14.2/bootstrap-table.js',
      'export' => 'https://cdnjs.cloudflare.com/ajax/libs/bootstrap-table/1.14.2/extensions/export/bootstrap-table-export.min.js',
      'tableexport' => 'https://unpkg.com/tableexport.jquery.plugin/tableExport.min.js',
      'autotable' => 'https://unpkg.com/tableexport.jquery.plugin/libs/jsPDF-AutoTable/jspdf.plugin.autotable.js',
      'pdf' => 'https://unpkg.com/tableexport.jquery.plugin/libs/jsPDF/jspdf.min.js',
      'css' => 'https://cdnjs.cloudflare.com/ajax/libs/bootstrap-table/1.14.2/bootstrap-table.css',

    ],
  ];
  //@todo set configurable all cdn in admin
  return !empty($lib_cdn[$name]) ? $lib_cdn[$name] : $lib_cdn;
}

/**
 * Implementation of hook_shortcode_info() .
 * Using the same formatting as hook_filter_info()
 */
function shortcode_bootstrap_shortcode_info() {
  $shortcodes['quote'] = [
    'title' => t('Quote'),
    'description' => t('Replace the given text formatted like as a quote.'),
    'process callback' => 'shortcode_bootstrap_quote',
    'process settings callback' => 'shortcode_bootstrap_quote_settings',
    'icon' => 'fa fa-quote-right',
    'tips callback' => 'shortcode_bootstrap_quote_tip',
    'child shortcode' => 'html',
    'description_field' => 'author',
  ];
  $shortcodes['testimonial'] = [
    'title' => t('Testimonial'),
    'description' => t('Testimonial with image'),
    'process callback' => 'shortcode_bootstrap_testimonial',
    'process settings callback' => 'shortcode_bootstrap_testimonial_settings',
    'icon' => 'fa fa-comment',
    'tips callback' => 'shortcode_bootstrap_quote_tip',
    'child shortcode' => 'html',
    'description_field' => 'author',
  ];
  $shortcodes['progress'] = [
    'title' => t('Progress Line'),
    'description' => t('Progress line with title and percents.'),
    'process callback' => 'shortcode_bootstrap_progress',
    'process backend callback' => 'shortcode_bootstrap_progress_backend',
    'process settings callback' => 'shortcode_bootstrap_progress_settings',
    'icon' => 'fa fa-tasks',
    'tips callback' => 'shortcode_bootstrap_progress_tip',
    'description_field' => 'title',
  ];
  $shortcodes['spacer'] = [
    'title' => t('Spacer'),
    'description' => t('Spacer without any content.'),
    'process callback' => 'shortcode_bootstrap_spacer',
    'process settings callback' => 'shortcode_bootstrap_spacer_settings',
    'process backend callback' => 'visualshortcodes_backend_nochilds',
    'tips callback' => 'shortcode_bootstrap_spacer_tip',
    'icon' => 'fa fa-square-o',
    'description_field' => 'height',
  ];
  $shortcodes['container'] = [
    'title' => t('Container box'),
    'description' => t('Container for content.'),
    'process callback' => 'shortcode_bootstrap_container',
    'icon' => 'fa fa-hdd-o',
    'tips callback' => 'shortcode_bootstrap_container_tip',
  ];
  $shortcodes['row'] = [
    'title' => t('Row for columns'),
    'description' => t('Container for cols.'),
    'process callback' => 'shortcode_bootstrap_row',
    'process backend callback' => 'visualshortcodes_backend_row',
    'icon' => 'fa fa-th-large',
    'child shortcode' => 'col',
  ];
  $shortcodes['col'] = [
    'title' => t('Column'),
    'description' => t('Column with size settings'),
    'process callback' => 'shortcode_bootstrap_col',
    'process backend callback' => 'visualshortcodes_backend_col',
    'process settings callback' => 'visualshortcodes_shortcode_col_settings',
    'icon' => 'fa fa-columns',
  ];
  $shortcodes['message'] = [
    'title' => t('Notification'),
    'description' => t('Dismissable Message.'),
    'process callback' => 'shortcode_bootstrap_message',
    'tips callback' => 'shortcode_bootstrap_message_tip',
    'process settings callback' => 'shortcode_bootstrap_message_settings',
    'icon' => 'fa fa-info-circle',
    'description_field' => 'icon',
  ];
  $shortcodes['button'] = [
    'title' => t('Button link'),
    'description' => t('Button linked to any page or content.'),
    'process callback' => 'shortcode_bootstrap_button',
    'tips callback' => 'shortcode_bootstrap_button_tip',
    'process settings callback' => 'shortcode_bootstrap_button_settings',
    'icon' => 'fa fa-bold',
    'description_field' => 'text',
  ];
  $shortcodes['service_box'] = [
    'title' => t('Service Box'),
    'description' => t('Service box with text.'),
    'process callback' => 'shortcode_bootstrap_servicebox',
    'tips callback' => 'shortcode_bootstrap_servicebox_tip',
    'process settings callback' => 'shortcode_bootstrap_servicebox_settings',
    'icon' => 'fa fa-star',
    'description_field' => 'title',
  ];
  $shortcodes['social_box'] = [
    'title' => t('Social Icon Box'),
    'description' => t('Social Icon Link with text.'),
    'process callback' => 'shortcode_bootstrap_socialbox',
    'process settings callback' => 'shortcode_bootstrap_socialbox_settings',
    'process backend callback' => 'visualshortcodes_backend_nochilds',
    'tips callback' => 'shortcode_bootstrap_socialbox_tip',
    'icon' => 'fa fa-facebook',
  ];
  $shortcodes['pricing_table'] = [
    'title' => t('Pricing Table'),
    'description' => t('Responsive Pricing Table.'),
    'process callback' => 'shortcode_bootstrap_pricing_table',
    'process settings callback' => 'shortcode_bootstrap_pricing_table_settings',
    'tips callback' => 'shortcode_bootstrap_pricing_table_tip',
    'child shortcode' => 'pricing_table_row',
    'icon' => 'fa fa-usd',
    'description_field' => 'title',
  ];
  $shortcodes['pricing_table_row'] = [
    'title' => t('Pricing Table Row'),
    'description' => t('Pricing Table Row'),
    'process callback' => 'shortcode_bootstrap_pricing_table_row',
    'process settings callback' => 'shortcode_bootstrap_pricing_table_row_settings',
    'icon' => 'fa fa-money',
    'description_field' => 'title',
  ];
  $shortcodes['view'] = [
    'title' => t('View'),
    'description' => t('Embed content - rendered View.'),
    'process callback' => 'shortcode_bootstrap_view',
    'process backend callback' => 'visualshortcodes_backend_nochilds',
    'process settings callback' => 'shortcode_bootstrap_view_settings',
    'tips callback' => 'shortcode_bootstrap_view_tip',
    'icon' => 'fa fa-sun-o',
    'description_callback' => 'shortcode_bootstrap_view_description',
  ];
  $shortcodes['block'] = [
    'title' => t('Block'),
    'description' => t('Render block.'),
    'process callback' => 'shortcode_bootstrap_block',
    'process backend callback' => 'visualshortcodes_backend_nochilds',
    'process settings callback' => 'shortcode_bootstrap_block_settings',
    'icon' => 'fa fa-file',
    'tips callback' => 'shortcode_bootstrap_block_tip',
    'description_callback' => 'shortcode_bootstrap_block_description',
  ];
  $shortcodes['node'] = [
    'title' => t('Node'),
    'description' => t('Render node'),
    'process callback' => 'shortcode_bootstrap_node',
    'process backend callback' => 'visualshortcodes_backend_nochilds',
    'process settings callback' => 'shortcode_bootstrap_node_settings',
    'tips callback' => 'shortcode_bootstrap_node_tip',
    'icon' => 'fa fa-file-o',
    'description_callback' => 'shortcode_bootstrap_node_description',
  ];
  $shortcodes['quicklinks'] = [
    'title' => t('Quick Links'),
    'description' => t('Expandable menu links.'),
    'process callback' => 'shortcode_bootstrap_quicklinks',
    'process settings callback' => 'shortcode_bootstrap_quicklinks_settings',
    'process backend callback' => 'visualshortcodes_backend_nochilds',
    'tips callback' => 'shortcode_bootstrap_quicklinks_tip',
    'icon' => 'fa fa-th-list',
  ];
  $shortcodes['video'] = [
    'title' => t('Video Iframe'),
    'description' => t('Iframe adaptive video.'),
    'process callback' => 'shortcode_bootstrap_video',
    'process settings callback' => 'shortcode_bootstrap_video_settings',
    'process backend callback' => 'visualshortcodes_backend_nochilds',
    'icon' => 'fa fa-video-camera',
    'tips callback' => 'shortcode_bootstrap_video_tip',
    'description_field' => 'url',
  ];
  $shortcodes['contact'] = [
    'title' => t('Contact Form'),
    'description' => t('Contact Form'),
    'process callback' => 'shortcode_bootstrap_contact',
    'tips callback' => 'shortcode_bootstrap_contact_tip',
    'process settings callback' => 'shortcode_bootstrap_contact_settings',
    'icon' => 'fa fa-envelope-o',
  ];
  $shortcodes['slider'] = [
    'title' => t('Slider container'),
    'description' => t('Slider for any content'),
    'process callback' => 'shortcode_bootstrap_slider',
    'process settings callback' => 'shortcode_bootstrap_slider_settings',
    'icon' => 'fa fa-arrows-h',
    'child shortcode' => 'slider_item',
    'description_field' => 'type',
  ];
  $shortcodes['slider_item'] = [
    'title' => t('Slider'),
    'description' => t('Slider item'),
    'process callback' => 'shortcode_bootstrap_slider_item',
    'icon' => 'fa fa-long-arrow-right',
  ];
  $shortcodes['sequence'] = [
    'title' => t('Sequence container'),
    'description' => t('Sequence for any content'),
    'process callback' => 'shortcode_bootstrap_sequence',
    'icon' => 'fa fa-sort-numeric-asc',
    'child shortcode' => 'sequence_item',
  ];
  $shortcodes['sequence_item'] = [
    'title' => t('Sequence'),
    'description' => t('Sequence item'),
    'process callback' => 'shortcode_bootstrap_sequence_item',
    'process settings callback' => 'shortcode_bootstrap_sequence_item_settings',
    'icon' => 'fa fa-long-arrow-down',
    'description_field' => 'type',
  ];
  $shortcodes['accordions'] = [
    'title' => t('Accordion container'),
    'description' => t('Animated Accordions wrapper.'),
    'process callback' => 'shortcode_bootstrap_accordions',
    'process settings callback' => 'shortcode_bootstrap_accordions_settings',
    'tips callback' => 'shortcode_bootstrap_accordions_tip',
    'child shortcode' => 'accordion',
    'icon' => 'fa fa-bars',
  ];
  $shortcodes['accordion'] = [
    'title' => t('Accordion item'),
    'description' => t('Accordion item.'),
    'process callback' => 'shortcode_bootstrap_accordion',
    'process settings callback' => 'shortcode_bootstrap_accordion_settings',
    'icon' => 'fa fa-minus',
    'description_field' => 'title',
  ];
  $shortcodes['image'] = [
    'title' => t('Image with caption'),
    'description' => t('Image with caption'),
    'process callback' => 'shortcode_bootstrap_image',
    'process settings callback' => 'shortcode_bootstrap_image_settings',
    'tips callback' => 'shortcode_bootstrap_image_tip',
    'icon' => 'fa fa-file-image-o',
  ];
  $shortcodes['gmap'] = [
    'title' => t('Google Map'),
    'description' => t('Google Map'),
    'process callback' => 'shortcode_bootstrap_map',
    'process settings callback' => 'shortcode_bootstrap_map_settings',
    'tips callback' => 'shortcode_bootstrap_map_tip',
    'icon' => 'fa fa-map-marker',
  ];
  $shortcodes['tabs'] = [
    'title' => t('Tabs container'),
    'description' => t('jQuery Tabs.'),
    'process callback' => 'shortcode_bootstrap_tabs',
    'process settings callback' => 'shortcode_bootstrap_tabs_settings',
    'tips callback' => 'shortcode_bootstrap_tabs_tip',
    'icon' => 'fa fa-folder-open',
    'child shortcode' => 'tab',
    'description_field' => 'type',
  ];
  $shortcodes['tab'] = [
    'title' => t('Tab'),
    'description' => t('Tab content.'),
    'process callback' => 'shortcode_bootstrap_tab',
    'process settings callback' => 'shortcode_bootstrap_tab_settings',
    'icon' => 'fa fa-folder',
    'description_field' => 'title',
  ];
  $shortcodes['hr'] = [
    'title' => t('Horizontal Rules'),
    'description' => t('Horizontal Line with spaces.'),
    'process callback' => 'shortcode_bootstrap_hr',
    'process settings callback' => 'shortcode_bootstrap_hr_settings',
    'process backend callback' => 'visualshortcodes_backend_nochilds',
    'tips callback' => 'shortcode_bootstrap_hr_tip',
    'icon' => 'fa fa-ellipsis-h',
    'description_field' => 'type',
  ];
  $shortcodes['title'] = [
    'title' => t('Title'),
    'description' => t('Title with optional underline.'),
    'process callback' => 'shortcode_bootstrap_title',
    'tips callback' => 'shortcode_bootstrap_title_tip',
    'process backend callback' => 'visualshortcodes_backend_nochilds',
    'process settings callback' => 'shortcode_bootstrap_title_settings',
    'icon' => 'fa fa-text-width',
    'description_field' => 'title',
  ];
  $shortcodes['sitemap'] = [
    'title' => t('Sitemap'),
    'description' => t('Website Sitemap'),
    'process callback' => 'shortcode_bootstrap_sitemap',
    'tips callback' => 'shortcode_bootstrap_sitemap_tip',
    'process backend callback' => 'visualshortcodes_backend_nochilds',
    'icon' => 'fa fa-sitemap',
    'description_field' => 'machine_name',
  ];
  $shortcodes['html'] = [
    'title' => t('HTML'),
    'description' => t('HTML code'),
    'process callback' => 'shortcode_bootstrap_html',
    'process backend callback' => 'visualshortcodes_backend_nochilds',
    'process settings callback' => 'visualshortcodes_shortcode_html_settings',
    'icon' => 'fa fa-code',
    'description_field' => 'text',
  ];
  $shortcodes['chart'] = [
    'title' => t('Chart'),
    'description' => t('Chart'),
    'process callback' => 'shortcode_bootstrap_chart',
    'process backend callback' => 'visualshortcodes_backend_nochilds',
    'process settings callback' => 'shortcode_bootstrap_chart_settings',
    'icon' => 'fa fa-bar-chart-o',
    'description_field' => 'type',
  ];
  $shortcodes['styledcontainer'] = [
    'title' => t('Frame Container'),
    'description' => t('Styled Container'),
    'process callback' => 'shortcode_bootstrap_styledcontainer',
    'process settings callback' => 'shortcode_bootstrap_styledcontainer_settings',
    'icon' => 'fa fa-strikethrough',
    'description_field' => 'type',
  ];
  $shortcodes['icon'] = [
    'title' => t('Icon'),
    'description' => t('FontAwesome or LivIcon'),
    'process callback' => 'shortcode_bootstrap_icon',
    'process backend callback' => 'visualshortcodes_backend_nochilds',
    'process settings callback' => 'shortcode_bootstrap_icon_settings',
    'icon' => 'fa fa-rocket',
  ];
  $shortcodes['textrotation'] = [
    'title' => t('Text Rotation'),
    'description' => t('FontAwesome or LivIcon'),
    'process callback' => 'shortcode_bootstrap_textrotation',
    'process backend callback' => 'visualshortcodes_backend_nochilds',
    'process settings callback' => 'shortcode_bootstrap_textrotation_settings',
    'icon' => 'fa fa-rotate-right',
    'description_field' => 'title',
  ];
  $shortcodes['table'] = [
    'title' => t('Table'),
    'description' => t('Bootstrap table'),
    'process callback' => 'shortcode_bootstrap_table',
    'process backend callback' => 'visualshortcodes_backend_nochilds',
    'process settings callback' => 'shortcode_bootstrap_table_settings',
    'icon' => 'fa fa-table',
    'description_field' => 'title',
  ];

  return $shortcodes;
}

function _shortcode_bootstrap_attributes($attrs) {
  if (empty($attrs)) {
    return '';
  }
  $allowed_attributes = [
    'class' => 'class',
    'extra_classes' => 'class',
    'href' => 'href',
    'id' => 'id',
    'animation' => 'data-appear-animation',
    'animation_delay' => 'data-appear-animation-delay',
    'style' => 'style',
    'extra_style' => 'style',
    'target' => 'target',
  ];
  if (isset($attrs['link']) && $attrs['link'] == $_GET['q']) {
    $attrs['class'] = (isset($attrs['class']) ? $attrs['class'] : '') . ' active';
  }
  $output = '';
  $attrs_array = [];
  foreach ($attrs as $name => $value) {
    $value = trim($value);
    if (strpos($name, 'style_') === 0) {
      $value_style = str_replace(['style_', '_'], ['', '-'], $name);
      if (strpos($value_style, 'border-radius') !== FALSE) {
        $value = strpos($value, '%') !== FALSE ? $value : (int) $value . 'px;';
        $value = '-webkit-' . $value_style . ': ' . $value . '; -moz-' . $value_style . ': ' . $value . '; ' . $value_style . ': ' . $value . ';';
      }
      elseif (strpos($name, 'margin') !== FALSE || strpos($name, 'padding') !== FALSE || strpos($name, 'width') !== FALSE || strpos($name, 'height') !== FALSE) {
        $value = strpos($value, '%') !== FALSE ? $value : (int) $value . 'px;';
        $value = $value_style . ': ' . $value;
      }
      elseif (strpos($name, 'color') !== FALSE) {
        $value = $value_style . ': #' . trim($value, '#') . ';';
      }
      elseif (strpos($value_style, 'image') !== FALSE) {
        $file = file_load($value);
        $filename = isset($file->uri) ? file_create_url($file->uri) : '';
        $value = $value_style . ': url("' . $filename . '");';
      }
      else {
        $value = $value_style . ': ' . $value . ';';
      }
      $name = 'style';
    }
    if (isset($allowed_attributes[$name])) {
      $name = $allowed_attributes[$name];
      if ($value !== '') {
        $attrs_array[$name] = (isset($attrs_array[$name]) ? $attrs_array[$name] . ' ' : '') . $value;
      }
    }
    elseif (strpos($name, 'data-') === 0) {
      if ($value !== '') {
        $attrs_array[$name] = (isset($attrs_array[$name]) ? $attrs_array[$name] . ' ' : '') . $value;
      }
    }
  }
  if (isset($attrs['style_background_color']) && strtolower(trim($attrs['style_background_color'], '#')) == '000000') {
    $attrs_array['class'] = (isset($attrs_array['class']) ? $attrs_array['class'] : '') . ' text-white';
  }
  if (isset($attrs['style_background_color']) && strtolower(trim($attrs['style_background_color'], '#')) == 'ffffff') {
    $attrs_array['class'] = (isset($attrs_array['class']) ? $attrs_array['class'] : '') . ' text-black';
  }
  if (isset($attrs['text_align']) && $attrs['text_align']) {
    $attrs_array['style'] = (isset($attrs_array['style']) ? $attrs_array['style'] : '') . ' text-align:' . $attrs['text_align'] . ';';
  }

  foreach ($attrs_array as $name => $value) {
    $output .= " $name = '$value'";
  }

  drupal_add_css(drupal_get_path('module', 'shortcode_bootstrap') . '/css/visualshortcodes.css');
  drupal_add_css(drupal_get_path('module', 'shortcode_bootstrap') . '/css/animate.css');

  if (!empty(libraries_get_path('jquery-easing'))) {
    drupal_add_js(libraries_get_path('jquery-easing') . '/jquery.easing.min.js');
  }
  else {
    drupal_add_js(shortcode_bootstrap_cdn('jquery-easing'), 'external');
  }
  if (!empty(libraries_get_path('jquery.appear'))) {
    drupal_add_js(libraries_get_path('jquery.appear') . '/jquery.appear.js');
  }
  else {
    drupal_add_js(shortcode_bootstrap_cdn('jquery.appear'), 'external');
  }
  if (!empty(libraries_get_path('jquery-sortable'))) {
    drupal_add_js(libraries_get_path('jquery-sortable') . '/jquery-sortable.js');
  }
  else {
    drupal_add_js(shortcode_bootstrap_cdn('jquery-sortable'), 'external');
  }
  drupal_add_js(drupal_get_path('module', 'shortcode_bootstrap') . '/js/shortcode_bootstrap.js');
  return $output;
}

function shortcode_bootstrap_spacer($attrs, $text) {
  $attrs['class'] = 'spacer ' . (isset($attrs['class']) ? $attrs['class'] : '');
  $text = '<div ' . _shortcode_bootstrap_attributes($attrs) . '></div>';
  return $text;
}

function shortcode_bootstrap_spacer_tip($format, $long) {
  $output = [];
  $output[] = '<p><strong>Spacer:</strong><br/>[spacer][/spacer]</br>';
  $output[] = '<strong>Available classes:</strong> <strong>xs</strong> - 10px <strong>sm</strong> - 20px <strong>md</strong> - 40px <strong>lg</strong> - 60px <strong>xlg</strong> - 80px</p>';
  return implode(' ', $output);
}

function shortcode_bootstrap_spacer_settings($attrs, $text) {
  $form['style_height'] = [
    '#type' => 'textfield',
    '#title' => t('Height'),
    '#default_value' => isset($attrs['style_height']) ? $attrs['style_height'] : '',
    '#attributes' => ['class' => ['form-control']],
  ];
  return $form;
}

function shortcode_bootstrap_progress_backend($attrs, $text, $el = '') {

  $colors = [
    'blue' => 'info',
    'green' => 'success',
    'orange' => 'warning',
    'red' => 'danger',
    'dark_blue' => 'primary',
    'grey' => 'default',
    'black' => '',
  ];
  $color = (isset($attrs['color']) && isset($colors[$attrs['color']])) ? $attrs['color'] : '';
  if (isset($attrs['type']) && $attrs['type'] == 'circle') {
    $attrs['class'] .= ' progress-circular progress-bar-' . $colors[$color];
    $text = '
    <div class="backend_preview">
      <div ' . _shortcode_bootstrap_attributes($attrs) . '>
        <div class="progress-value">' . $attrs['percent'] . '%</div>
       </div>
     </div>';
  }
  else {
    $attrs['class'] .= ' progress';
    $text = '
    <div class="backend_preview">
      <div ' . _shortcode_bootstrap_attributes($attrs) . '>
        <div role="progressbar" aria-valuenow="' . $attrs['percent'] . '" aria-valuemin="0" aria-valuemax="100"  class="progress-bar progress-bar-striped progress-bar-' . $colors[$color] . '" style="width: ' . $attrs['percent'] . '%;">' . $attrs["title"] . ' ' . $attrs['percent'] . '%</div>
      </div>
    </div>';
  }
  return $text;
}

function shortcode_bootstrap_progress($attrs, $text) {
  $attrs['class'] = isset($attrs['class']) ? $attrs['class'] : '';
  $attrs['class'] .= isset($attrs['animated']) && $attrs['animated'] ? ' active' : '';
  $attrs['class'] .= isset($attrs['striped']) && $attrs['striped'] ? ' progress-striped' : '';
  $attrs['class'] .= isset($attrs['hover']) && $attrs['hover'] ? ' hover' : '';

  $colors = [
    'blue' => 'info',
    'green' => 'success',
    'orange' => 'warning',
    'red' => 'danger',
    'dark_blue' => 'primary',
    'grey' => 'default',
    'black' => '',
  ];
  $color = (isset($attrs['color']) && isset($colors[$attrs['color']])) ? $attrs['color'] : '';
  $text = isset($attrs['title']) && $attrs['title'] ? $attrs['title'] : $text;
  if (isset($attrs['type']) && $attrs['type'] == 'circle') {
    $attrs['class'] .= ' progress-circular';
    $line_color = isset($attrs['custom_color']) && $attrs['custom_color'] ? '#' . trim($attrs['custom_color'], '#') : '#f2f2f2';
    $text = '<div ' . _shortcode_bootstrap_attributes($attrs) . '>
       <input type="text" class="knob" value="0" rel="' . $attrs['percent'] . '" data-linecap="round" data-width="200" data-bgColor="#f2f2f2" data-fgColor="' . $line_color . '" data-thickness=.15 data-readOnly=true disabled>
      </div>';
  }
  else {
    $attrs['class'] .= ' progress';
    $text = '<div ' . _shortcode_bootstrap_attributes($attrs) . ' data-appear-progress-animation="' . $attrs['percent'] . '%">
      <div role="progressbar" aria-valuenow="' . $attrs['percent'] . '" aria-valuemin="0" aria-valuemax="100"  class="progress-bar progress-bar-striped progress-bar-' . $colors[$color] . '">' . $text . ' <span class = "progress-percent">' . $attrs['percent'] . '%</span></div>
    </div>';
  }
  if (!empty(libraries_get_path('jQuery-Knob'))) {
    drupal_add_js(libraries_get_path('jQuery-Knob') . '/dist/jquery.knob.min.js');
  }
  else {
    drupal_add_js(shortcode_bootstrap_cdn('jQuery-Knob'), 'external');
  }
  drupal_add_js(drupal_get_path('module', 'shortcode_bootstrap') . '/js/shortcode_bootstrap.js');

  return $text;
}

function shortcode_bootstrap_progress_settings($attrs, $text) {
  $attrs['title'] = isset($attrs['title']) && $attrs['title'] ? $attrs['title'] : $text;
  $form['title'] = [
    '#type' => 'textfield',
    '#title' => t('Title'),
    '#default_value' => isset($attrs['title']) ? $attrs['title'] : '',
    '#attributes' => ['class' => ['form-control']],
    '#prefix' => '<div class = "row"><div class = "col-sm-7">',
    '#states' => [
      'invisible' => [
        '.progess-type-select' => ['value' => 'circle'],
      ],
    ],
  ];
  $colors = [
    'blue' => t('Blue'),
    'green' => t('Green'),
    'orange' => t('Orange'),
    'red' => t('Red'),
    'black' => t('Black'),
    'dark_blue' => t('Dark blue'),
    'grey' => t('Grey'),
  ];
  $form['color'] = [
    '#type' => 'radios',
    '#title' => t('Color'),
    '#options' => $colors,
    '#default_value' => isset($attrs['color']) ? $attrs['color'] : 'blue',
    '#attributes' => ['class' => ['color-radios']],
    '#prefix' => '</div><div class = "col-sm-3">',
    '#states' => [
      'visible' => [
        '.progess-type-select' => ['value' => 'line'],
      ],
    ],
  ];
  $form['percent'] = [
    '#type' => 'textfield',
    '#title' => t('Percent'),
    '#default_value' => isset($attrs['percent']) ? $attrs['percent'] : '',
    '#attributes' => ['class' => ['form-control']],
    '#prefix' => '</div><div class = "col-sm-2">',
    '#suffix' => '</div></div>',
  ];
  $types = ['line' => t('Line'), 'circle' => t('Circle')];
  $form['type'] = [
    '#type' => 'select',
    '#title' => t('Type'),
    '#options' => $types,
    '#default_value' => isset($attrs['type']) ? $attrs['type'] : 'line',
    '#attributes' => ['class' => ['form-control progess-type-select']],
    '#prefix' => '<div class = "row"><div class = "col-sm-3">',
  ];
  $form['striped'] = [
    '#type' => 'checkbox',
    '#title' => t('Striped'),
    '#default_value' => isset($attrs['striped']) ? $attrs['striped'] : '',
    '#prefix' => '</div><div class = "col-sm-3">',
    '#states' => [
      'visible' => [
        '.progess-type-select' => ['value' => 'line'],
      ],
    ],
  ];
  $form['animated'] = [
    '#type' => 'checkbox',
    '#title' => t('Animated'),
    '#default_value' => isset($attrs['animated']) ? $attrs['animated'] : '',
    '#prefix' => '</div><div class = "col-sm-3">',
    '#states' => [
      'visible' => [
        '.progess-type-select' => ['value' => 'line'],
      ],
    ],
  ];
  $form['hover'] = [
    '#type' => 'checkbox',
    '#title' => t('Hover Animation'),
    '#default_value' => isset($attrs['hover']) ? $attrs['hover'] : '',
    '#prefix' => '</div><div class = "col-sm-3">',
    '#states' => [
      'visible' => [
        '.progess-type-select' => ['value' => 'line'],
      ],
    ],
  ];
  $form['custom_color'] = [
    '#type' => 'textfield',
    '#title' => t('Color'),
    '#default_value' => isset($attrs['custom_color']) ? $attrs['custom_color'] : '',
    '#states' => [
      'invisible' => [
        '.progess-type-select' => ['value' => 'line'],
      ],
    ],
    '#attributes' => ['class' => ['form-control colorpicker-enable']],
    '#prefix' => '</div><div class = "col-sm-3">',
    '#suffix' => '</div></div>',
  ];
  return $form;
}

function shortcode_bootstrap_progress_tip($format, $long) {
  $output = [];
  $output[] = '<p><strong>Progress bar:</strong><br/>[progress percent = "90" color = "blue"]Design[/progress]</br>';
  return implode(' ', $output);
}

function shortcode_bootstrap_video($attrs, $text) {
  $attrs['class'] = isset($attrs['class']) ? ' ' . $attrs['class'] : '';
  $attrs['url'] = isset($attrs['url']) && $attrs['url'] ? $attrs['url'] : $text;
  $iframe_attrs = (isset($attrs['width']) ? 'width="' . $attrs['width'] . '"' : '') . (isset($attrs['height']) ? ' height ="' . $attrs['height'] . '"' : '');
  if (!$iframe_attrs) {
    $attrs['class'] .= ' video-box';
  }
  $parse = parse_url($attrs['url']);
  if (strpos($parse["host"], 'vimeo') !== FALSE) {
    $attrs['class'] .= ' vimeo';
    $id = str_replace('/', '', $parse["path"]);
    $video_url = '//player.vimeo.com/video/' . $id;
  }
  elseif (strpos($parse["host"], 'youtube') !== FALSE) {
    $attrs['class'] .= ' youtube';
    if (!empty($parse['query'])) {
      $id = str_replace('v=', '', $parse['query']) . '?showinfo=0&amp;wmode=opaque';
    }
    elseif (strpos($parse["path"], '/embed/') !== FALSE) {
      $id = str_replace('/embed/', '', $parse["path"]);
    }
    $video_url = '//' . $parse["host"] . '/embed/' . $id;
  }
  $text = '<div  ' . _shortcode_bootstrap_attributes($attrs) . '>
    <iframe src="' . $video_url . '" ' . $iframe_attrs . '  frameborder="0" webkitallowfullscreen="" mozallowfullscreen="" allowfullscreen=""></iframe>
  </div>';
  return $text;
}

function shortcode_bootstrap_video_settings($attrs, $text) {
  $attrs['url'] = isset($attrs['url']) && $attrs['url'] ? $attrs['url'] : $text;
  $form['url'] = [
    '#type' => 'textfield',
    '#title' => t('Video Url'),
    '#default_value' => isset($attrs['url']) ? $attrs['url'] : '',
    '#attributes' => ['class' => ['form-control']],
    '#description' => t('Supports: YouTube and Vimeo <br/>Instead of linking to youtube.com, link to youtube-nocookie.com, and no data-collecting HTTP cookie will be sent'),
  ];
  $form['width'] = [
    '#type' => 'textfield',
    '#title' => t('Width'),
    '#default_value' => isset($attrs['width']) ? $attrs['width'] : '',
    '#attributes' => ['class' => ['form-control']],
    '#prefix' => '<div class = "row"><div class = "col-sm-6">',
  ];
  $form['height'] = [
    '#type' => 'textfield',
    '#title' => t('Height'),
    '#default_value' => isset($attrs['height']) ? $attrs['height'] : '',
    '#attributes' => ['class' => ['form-control']],
    '#prefix' => '</div><div class = "col-sm-6">',
    '#suffix' => '</div></div>',
  ];
  return $form;
}

function shortcode_bootstrap_video_tip($format, $long) {
  $output = [];
  $output[] = '<p><strong>Video iFrame:</strong><br/>[video]player.vimeo.com/video/[/video]</br>';
  $output[] = '<strong>Text</strong> - Embed URL of the video.</p>';
  return implode(' ', $output);
}

function shortcode_bootstrap_contact($attrs, $text) {
  $text = '';
  if (user_access('access site-wide contact form') && module_exists('contact')) {
    if (!flood_is_allowed('contact', variable_get('contact_hourly_threshold', 3))) {
      $text = t("You cannot send more than %number messages per hour. Please try again later.", ['%number' => variable_get('contact_hourly_threshold', 3)]);
    }
    else {
      module_load_include('inc', 'contact', 'contact.pages');
      $content = drupal_get_form('contact_site_form');
      // Allow users to alter contact form fields
      $alter_fields = ['name', 'mail', 'subject', 'message'];
      foreach ($alter_fields as $field) {
        if (isset($attrs[$field])) {
          $content[$field]['#title'] = t($attrs[$field]);
          $content[$field]['#attributes']['placeholder'] = t($attrs[$field]);
        }
      }
      $title = isset($attrs['title']) ? '<h3 class="title">' . $attrs['title'] . '</h3>' : '';
      $content['name']['#prefix'] = $title;
      $text = '<div class = "login-register"><div ' . _shortcode_bootstrap_attributes($attrs) . '>' . drupal_render($content) . '</div></div>';
    }
  }
  return $text;
}

function shortcode_bootstrap_contact_tip($format, $long) {
  $output = [];
  $output[] = '<p><strong>Contact Form:</strong><br/>[contact name = "Name field Title"][/contact]</br>';
  $output[] = 'Override default title for fields: <strong>name</strong>, <strong>subject</strong>, <strong>mail</strong>, <strong>message</strong></p>';
  return implode(' ', $output);
}

function shortcode_bootstrap_contact_settings($attrs, $text) {
  $form['title'] = [
    '#type' => 'textfield',
    '#title' => t('Main Title'),
    '#default_value' => isset($attrs['title']) ? $attrs['title'] : '',
    '#attributes' => ['class' => ['form-control']],
  ];
  $form['name'] = [
    '#type' => 'textfield',
    '#title' => t('Name'),
    '#default_value' => isset($attrs['name']) ? $attrs['name'] : '',
    '#attributes' => ['class' => ['form-control']],
    '#prefix' => t('Override fields titles:') . '<div class = "row"><div class = "col-sm-6">',
  ];
  $form['mail'] = [
    '#type' => 'textfield',
    '#title' => t('Email'),
    '#default_value' => isset($attrs['mail']) ? $attrs['mail'] : '',
    '#attributes' => ['class' => ['form-control']],
    '#prefix' => '</div><div class = "col-sm-6">',
    '#suffix' => '</div></div>',
  ];
  $form['subject'] = [
    '#type' => 'textfield',
    '#title' => t('Subject'),
    '#default_value' => isset($attrs['subject']) ? $attrs['subject'] : '',
    '#attributes' => ['class' => ['form-control']],
    '#prefix' => '<div class = "row"><div class = "col-sm-6">',
  ];
  $form['message'] = [
    '#type' => 'textfield',
    '#title' => t('Message'),
    '#default_value' => isset($attrs['message']) ? $attrs['message'] : '',
    '#attributes' => ['class' => ['form-control']],
    '#prefix' => '</div><div class = "col-sm-6">',
    '#suffix' => '</div></div>',
  ];

  return $form;
}

function shortcode_bootstrap_slider($attrs, $text) {
  $attrs['class'] = ' carousel slide ' . (isset($attrs['class']) ? $attrs['class'] : '');
  $attrs['data-ride'] = 'carousel';
  if (empty($attrs['id'])) {
    $attrs['id'] = base64_encode(random_bytes(5));;
  }
  $pagination = '';
  if (in_array($attrs['type'], ['pagination', 'navigation']) && 0) {
    $pagination = '<div class = "carousel-pagination carousel-box">
      <a class="next" href="#' . $attrs['id'] . '">
          <i class="fa chevron-circle-left"></i>
      </a>
      <a class="prev" href="#' . $attrs['id'] . '">
          <i class="fa chevron-circle-right"></i>
      </a>
    </div>';
  }
  $pagination_switches = '';
  switch ($attrs['type']) {
    case 'autoscroll':
      $attrs['data-carousel-autoplay'] = 'true';
      $attrs['data-carousel-nav'] = 'false';
      $attrs['data-carousel-one'] = 'true';
      $attrs['data-duration'] = isset($attrs['duration']) ? $attrs['duration'] : 1000;
      break;
    case 'navigation':
      $attrs['data-carousel-pagination'] = 'true';
      $attrs['data-carousel-nav'] = 'false';
      $attrs['data-carousel-one'] = 'true';
      $pagination_switches = '
    <a class="left carousel-control" href="#' . $attrs['id'] . '" data-slide="prev">
      <span class="glyphicon glyphicon-chevron-left"></span>
      <span class="sr-only">' . t('Previous') . '</span>
    </a>
    <a class="right carousel-control" href="#' . $attrs['id'] . '" data-slide="next">
      <span class="glyphicon glyphicon-chevron-right"></span>
      <span class="sr-only">' . t('Next') . '</span>
    </a>';
      break;
    case 'pagination':
      $attrs['style_margin_top'] = isset($attrs['style_margin_top']) ? $attrs['style_margin_top'] : '-40px';
      $attrs['data-carousel-one'] = 'true';
      $attrs['class'] .= ' allow-overflow';
      $total_slider = substr_count($text, 'class="item"');
      $pagination = '<ol class = "carousel-indicators carousel-pagination carousel-box">';
      foreach (range(0, $total_slider - 1) as $index) {
        $active = $index ? '' : 'active';
        $pagination .= '<li data-target="#' . $attrs['id'] . '" data-slide-to="' . $index . '" class="' . $active . '"></li>';
      }
      $pagination .= '</ol>';
      break;
  }
  //first item must be active
  $search = 'class="item"';
  $replace = 'class="item active"';
  $pos = strpos($text, $search);
  if ($pos !== FALSE) {
    $text = substr($text, 0, $pos) . $replace . substr($text, $pos + strlen($search));
  }
  $output = '
  <div ' . _shortcode_bootstrap_attributes($attrs) . '>
    ' . $pagination . '
    <div class="carousel-inner">
      ' . $text . '
    </div>
    ' . $pagination_switches . '
  </div>
  ';

  return $output;
}

function shortcode_bootstrap_slider_settings($attrs, $text) {
  $types = [
    'autoscroll' => t('Autoscroll'),
    'pagination' => t('Pagination'),
    'navigation' => t('Navigation'),
    'pagination_navigation' => t('Pagination & Navigation'),
  ];
  $form['type'] = [
    '#type' => 'select',
    '#options' => $types,
    '#title' => t('Type'),
    '#default_value' => isset($attrs['type']) ? $attrs['type'] : 'autoscroll',
    '#attributes' => ['class' => ['form-control slider-type-selector']],
    '#prefix' => '<div class = "row"><div class = "col-sm-6">',
  ];
  $form['duration'] = [
    '#type' => 'textfield',
    '#title' => t('Auto Scroll Duration (ms)'),
    '#default_value' => isset($attrs['duration']) ? $attrs['duration'] : '1000',
    '#attributes' => ['class' => ['form-control']],
    '#prefix' => '</div><div class = "col-sm-6">',
    '#suffix' => '</div></div>',
    '#states' => [
      'visible' => [
        '.slider-type-selector' => ['value' => 'autoscroll'],
      ],
    ],
  ];
  return $form;
}

function shortcode_bootstrap_slider_item($attrs, $text, $el = '') {
  $attrs['class'] = 'col-sm-12 col-md-12' . (isset($attrs['class']) ? $attrs['class'] : '');
  return '<div class="item"><div ' . _shortcode_bootstrap_attributes($attrs) . '>' . $text . '</div></div>';
}


function shortcode_bootstrap_sequence($attrs, $text) {
  $attrs['class'] = 'steps ' . (isset($attrs['class']) ? $attrs['class'] : '');
  return '<div ' . _shortcode_bootstrap_attributes($attrs) . '>
    ' . $text . '
  </div>';
}

function shortcode_bootstrap_sequence_item($attrs, $text, $parent_attrs) {
  $attrs['class'] = 'step ' . (isset($attrs['class']) ? $attrs['class'] : '');
  $attrs['class'] .= 'border-' . $attrs['color'];
  $attrs['class'] .= in_array($attrs['type'], [
    'background',
    'image_background',
  ]) ? ' white bg-' . $attrs['color'] : '';
  $bg_img = '';
  if ($attrs['type'] == 'image_background' && isset($attrs['image_fid']) && $attrs['image_fid']) {
    $inner_attrs = [
      'class' => 'bg-image',
      'style_background_image' => $attrs['image_fid'],
    ];
    $bg_img = '<div ' . _shortcode_bootstrap_attributes($inner_attrs) . '></div>';
  }
  return '<div ' . _shortcode_bootstrap_attributes($attrs) . '>' . $bg_img . '<div class = "step-wrapper">' . $text . '</div></div>';
}

function shortcode_bootstrap_sequence_item_settings($attrs, $text) {
  $colors = [
    'warning' => t('Orange'),
    'error' => t('Red'),
    'success' => t('Green'),
    'info' => t('Blue'),
    'primary' => t('Dark blue'),
    'grey' => t('Grey'),
  ];
  $form['color'] = [
    '#type' => 'radios',
    '#title' => t('Color'),
    '#options' => $colors,
    '#default_value' => isset($attrs['color']) ? $attrs['color'] : 'warning',
    '#attributes' => ['class' => ['color-radios']],
    '#prefix' => '</div><div class = "col-sm-6">',
  ];
  $types = [
    'background' => t('Background'),
    'border' => t('Border'),
    'image_background' => t('Image Background'),
  ];
  $form['type'] = [
    '#type' => 'select',
    '#options' => $types,
    '#title' => t('Type'),
    '#default_value' => isset($attrs['type']) ? $attrs['type'] : 'background',
    '#attributes' => ['class' => ['form-control type-sequence-select']],
    '#prefix' => '<div class = "row"><div class = "col-sm-6">',
    '#suffix' => '</div></div>',
  ];
  $filename = isset($attrs['image_fid']) && !empty($attrs['image_fid']) ? file_load($attrs['image_fid'])->uri : '';
  $image = $filename ? theme('image_style', [
    'style_name' => 'media_thumbnail',
    'path' => $filename,
  ]) : '';
  $form['image_fid'] = [
    '#type' => 'textfield',
    '#title' => t('Image'),
    '#default_value' => isset($attrs['image_fid']) ? $attrs['image_fid'] : '',
    '#states' => [
      'visible' => [
        '.type-sequence-select' => ['value' => 'image_background'],
      ],
    ],
    '#attributes' => ['class' => ['image-media-upload hidden']],
    '#field_suffix' => '<div class = "preview-image">' . $image . '</div><a href = "#" class = "media-upload button">' . t('Upload Image') . '</a><a href = "#" class = "media-remove button">' . t('Remove Image') . '</a>',
  ];

  return $form;
}

function shortcode_bootstrap_quote($attrs, $text) {
  if (isset($attrs['blockquote']) && $attrs['blockquote']) {
    $output = '<blockquote ' . _shortcode_bootstrap_attributes($attrs) . '>
      <p>' . $text . ' </p>
      ' . ($attrs['author'] ? '<small>' . $attrs['author'] . '</small>' : '') . '
    </blockquote>';
  }
  else {
    $attrs['class'] = (isset($attrs['class']) ? $attrs['class'] : '') . ' quote centered';
    if (isset($attrs['image']) && $attrs['image']) {
      $img = $attrs['image'];
    }
    elseif (isset($attrs['image_fid']) && $attrs['image_fid']) {
      $file = file_load($attrs['image_fid']);
      $img = isset($file->uri) ? $file->uri : '';
    }
    $h = isset($img) ? '4' : '2';
    $img = isset($img) ? theme('image', ['path' => $img]) : '';
    $output = '<div ' . _shortcode_bootstrap_attributes($attrs) . '>
      ' . $img . '
      <h' . $h . '><i class="fa fa-quote-left highlight"></i> ' . $text . ' <i class="fa fa-quote-right highlight"></i></h' . $h . '>
      <p class="label label-primary">' . $attrs['author'] . '</p>
    </div>';
  }
  return $output;
}

function shortcode_bootstrap_quote_tip($format, $long) {
  $output = [];
  $output[] = '<p>All elements supports <strong>class</strong>, <strong>animation</strong> and <strong>delay</strong> attributes. Supports all <a href = "http://daneden.github.io/animate.css/">animation.css</a> values. Delay value in ms. ';
  $output[] = '<p><strong>Quote:</strong><br/>[quote author = "Author Name" image = "/files/author.png" blockquote]text[/quote]</br>';
  $output[] = '<strong>blockquote</strong> - Simple left aligned quote with author name, <strong>image</strong> - URL to the image.</p>';
  return implode(' ', $output);
}

function shortcode_bootstrap_quote_settings($attrs, $text) {
  $form['blockquote'] = [
    '#type' => 'checkbox',
    '#title' => t('Blockquote'),
    '#default_value' => isset($attrs['blockquote']) ? $attrs['blockquote'] : 0,
    '#attributes' => ['class' => ['blockquote-shortcode-flag']],
  ];
  $form['author'] = [
    '#type' => 'textfield',
    '#title' => t('Author'),
    '#default_value' => isset($attrs['author']) ? $attrs['author'] : '',
    '#attributes' => ['class' => ['form-control']],
  ];
  $file = isset($attrs['image_fid']) && !empty($attrs['image_fid']) ? file_load($attrs['image_fid']) : '';
  $filename = isset($file->uri) ? $file->uri : (isset($attrs['image']) ? $attrs['image'] : '');
  $image = $filename ? theme('image_style', [
    'style_name' => 'media_thumbnail',
    'path' => $filename,
  ]) : '';
  $form['image_fid'] = [
    '#type' => 'textfield',
    '#title' => t('Image'),
    '#default_value' => isset($attrs['image_fid']) ? $attrs['image_fid'] : '',
    '#states' => [
      'visible' => [
        '.blockquote-shortcode-flag' => ['checked' => FALSE],
      ],
    ],
    '#attributes' => ['class' => ['image-media-upload hidden']],
    '#field_suffix' => '<div class = "preview-image">' . $image . '</div><a href = "#" class = "media-upload button">' . t('Upload Image') . '</a><a href = "#" class = "media-remove button">' . t('Remove Image') . '</a>',
  ];
  // Added only to save the old image attribute
  if (isset($attrs['image']) && !isset($attrs['image_fid']) && !$attrs['image_fid']) {
    $form['image'] = [
      '#type' => 'textfield',
      '#default_value' => $attrs['image'],
      '#attributes' => ['class' => ['hidden fid-old-field']],
    ];
  }
  return $form;
}

function shortcode_bootstrap_testimonial($attrs, $text) {
  $attrs['class'] = 'respond ' . (isset($attrs['type']) ? $attrs['type'] : '');
  $class = 'description ' . $attrs['type'] . (isset($attrs['color']) && $attrs['color'] != 'default-testimonial' ? '-' . $attrs['color'] : '');
  $file = isset($attrs['image_fid']) && !empty($attrs['image_fid']) ? file_load($attrs['image_fid']) : '';
  $img = isset($file->uri) ? $file->uri : '';
  $img = $img ? theme('image', [
    'path' => $img,
    'attributes' => ['class' => ['img-circle']],
  ]) : '';
  $output = '<div class = "' . $class . '">' . $text . '</div>
  <div class = "name"><div class = "icon">' .
    ($img ? $img : '<i class="fa fa-user"></i>') . '</div>' .
    (isset($attrs['author']) && $attrs['author'] ? '<strong>' . $attrs['author'] . '</strong>' : '') .
    (isset($attrs['author_info']) && $attrs['author_info'] ? '<a href = "#" class = "no-border">' . $attrs['author_info'] . '</a>' : '') . '
  </div>';

  return '<div ' . _shortcode_bootstrap_attributes($attrs) . '>' . $output . '</div>';
}

function shortcode_bootstrap_testimonial_settings($attrs, $text) {
  $types = ['border' => t('Border color'), 'bg' => t('Background color')];
  $form['type'] = [
    '#type' => 'select',
    '#options' => $types,
    '#title' => t('Type'),
    '#default_value' => isset($attrs['type']) ? $attrs['type'] : 'border-',
    '#attributes' => ['class' => ['form-control blockquote-shortcode-flag']],
    '#prefix' => '<div class = "row"><div class = "col-sm-6">',
  ];
  $colors = [
    'default-testimonial' => t('Default'),
    'primary' => t('Dark Blue'),
    'warning' => t('Orange'),
    'error' => t('Red'),
    'success' => t('Green'),
    'info' => t('Blue'),
  ];
  $form['color'] = [
    '#type' => 'radios',
    '#title' => t('Color'),
    '#options' => $colors,
    '#default_value' => isset($attrs['color']) ? $attrs['color'] : '',
    '#attributes' => ['class' => ['color-radios form-control']],
    '#prefix' => '</div><div class = "col-sm-6">',
    '#suffix' => '</div></div>',
  ];

  $form['author'] = [
    '#type' => 'textfield',
    '#title' => t('Author'),
    '#default_value' => isset($attrs['author']) ? $attrs['author'] : '',
    '#attributes' => ['class' => ['form-control']],
    '#prefix' => '<div class = "row"><div class = "col-sm-6">',
  ];
  $form['author_info'] = [
    '#type' => 'textfield',
    '#title' => t('Author info'),
    '#default_value' => isset($attrs['author_info']) ? $attrs['author_info'] : '',
    '#attributes' => ['class' => ['form-control']],
    '#prefix' => '</div><div class = "col-sm-6">',
    '#suffix' => '</div></div>',
  ];

  $filename = isset($attrs['image_fid']) && !empty($attrs['image_fid']) ? file_load($attrs['image_fid'])->uri : (isset($attrs['image']) ? $attrs['image'] : '');
  $image = $filename ? theme('image_style', [
    'style_name' => 'media_thumbnail',
    'path' => $filename,
  ]) : '';
  $form['image_fid'] = [
    '#type' => 'textfield',
    '#title' => t('Image'),
    '#default_value' => isset($attrs['image_fid']) ? $attrs['image_fid'] : '',
    '#states' => [
      'visible' => [
        '.blockquote-shortcode-flag' => ['checked' => FALSE],
      ],
    ],
    '#attributes' => ['class' => ['image-media-upload hidden']],
    '#field_suffix' => '<div class = "preview-image">' . $image . '</div><a href = "#" class = "media-upload button">' . t('Upload Image') . '</a><a href = "#" class = "media-remove button">' . t('Remove Image') . '</a>',
  ];
  return $form;
}

function shortcode_bootstrap_servicebox($attrs, $text) {
  $attrs['link'] = isset($attrs['link']) ? (strpos($attrs['link'], '#') === FALSE ? url($attrs['link']) : $attrs['link']) : '';
  $attrs['type'] = isset($attrs['type']) ? $attrs['type'] : 'center_big';
  $attrs['inner_animation'] = isset($attrs['inner_animation']) ? ' data-appear-animation="' . $attrs['inner_animation'] . '"' : '';
  $attrs['inner_icon_animation'] = $attrs['inner_animation'] ? 'data-appear-animation="wobble"' : '';
  $attrs['link_text'] = isset($attrs['link_text']) ? $attrs['link_text'] : t('Read More');
  switch ($attrs['type']) {
    case 'left_small':
      $attrs['class'] = 'text-small features-block' . (isset($attrs['class']) ? ' ' . $attrs['class'] : '');
      $text = '<div ' . _shortcode_bootstrap_attributes($attrs) . '>
        <a class = "header-box" href = "' . $attrs['link'] . '">
        ' . (isset($attrs['icon']) ? '<div class="icon-box" ' . $attrs['inner_icon_animation'] . '><i class="' . $attrs['icon'] . '"></i></div>' : '') . '
        ' . (isset($attrs['title']) ? '<h6 ' . $attrs['inner_animation'] . '>' . $attrs['title'] . '</h6>' : '') . '        
        </a>
        <div ' . $attrs['inner_animation'] . '>
          ' . $text . '
        </div>
      </div>';
      break;
    case 'left_medium':
      $attrs['class'] = 'service' . (isset($attrs['class']) ? ' ' . $attrs['class'] : '');
      $text = '<div ' . _shortcode_bootstrap_attributes($attrs) . '>
        <a href = "' . $attrs['link'] . '">' .
        (isset($attrs['icon']) ? '<div class="icon bg" ' . $attrs['inner_icon_animation'] . '><i class="' . $attrs['icon'] . '"></i></div>' : '') .
        (isset($attrs['title']) ? '<h6 class = "title" ' . $attrs['inner_animation'] . '>' . $attrs['title'] . '</h6>' : '') . '        
          <div class = "text-small" ' . $attrs['inner_animation'] . '>' .
        $text . '
          </div>
        </a>
      </div>';
      break;
    case 'left_big':
      $attrs['class'] = (isset($attrs['class']) ? $attrs['class'] : '');
      $text = '<div ' . _shortcode_bootstrap_attributes($attrs) . '>' .
        (isset($attrs['icon']) ? '<a href = "' . $attrs['link'] . '" class="big-icon bg pull-left" ' . $attrs['inner_icon_animation'] . '><i class="' . $attrs['icon'] . '"></i></a>' : '') .
        (isset($attrs['title']) ? '<h3 ' . $attrs['inner_animation'] . '>' . $attrs['title'] . '</h3>' : '') . '
        <p ' . $attrs['inner_animation'] . '>
          ' . $text . '
        </p>
      </div>';
      break;
    case 'center_big':
    default:
      $attrs['class'] = 'big-services-box' . (isset($attrs['class']) ? ' ' . $attrs['class'] : '');
      $text = '<div ' . _shortcode_bootstrap_attributes($attrs) . '>
        ' . (isset($attrs['icon']) ? '<div class="big-icon bg" ' . $attrs['inner_icon_animation'] . '><i class="' . $attrs['icon'] . '"></i></div>' : '') . '
        ' . (isset($attrs['title']) ? '<h4 class="title" ' . $attrs['inner_animation'] . '>' . $attrs['title'] . '</h4>' : '') . '
        <div class="text-small" ' . $attrs['inner_animation'] . '>
          ' . $text . '
          <div class="clearfix"></div><br>
          ' . ($attrs['link'] ? '<a class="btn btn-default" href = "' . $attrs['link'] . '">' . $attrs['link_text'] . '</a>' : '') . '
        </div>
      </div>';
      break;
  }
  return $text;
}

function shortcode_bootstrap_servicebox_tip($format, $long) {
  $output = [];
  $output[] = '<p><strong>Icon Box:</strong><br/>[service_box icon = "fa fa-user" link_text = "More" title = "Title" link = "contact"]Text[/service_box]</br>';
  $output[] = 'Available attributes: <strong>icon</strong> - Icon font class, <strong>link</strong>, <strong>link_text</strong>, <strong>title</strong></p>';
  return implode(' ', $output);
}


function shortcode_bootstrap_servicebox_settings($attrs, $text) {
  $form['title'] = [
    '#type' => 'textfield',
    '#title' => t('Title'),
    '#default_value' => isset($attrs['title']) ? $attrs['title'] : '',
    '#attributes' => ['class' => ['form-control']],
    '#prefix' => '<div class = "row"><div class = "col-sm-6">',
  ];
  $form['link'] = [
    '#type' => 'textfield',
    '#title' => t('Link'),
    '#default_value' => isset($attrs['link']) ? $attrs['link'] : '',
    '#attributes' => ['class' => ['form-control']],
    '#prefix' => '</div><div class = "col-sm-6">',
    '#suffix' => '</div></div>',
  ];
  $types = [
    'left_small' => t('Left Small'),
    'left_medium' => t('Left Medium'),
    'left_big' => t('Left Big'),
    'center_big' => t('Center Big'),
  ];
  $form['type'] = [
    '#title' => t('Icon Type'),
    '#type' => 'select',
    '#options' => $types,
    '#default_value' => isset($attrs['type']) ? $attrs['type'] : 'center_big',
    '#attributes' => ['class' => ['form-control type-icon-select']],
    '#prefix' => '<div class = "row"><div class = "col-sm-2">',
  ];
  $form['icon'] = [
    '#title' => t('Icon'),
    '#type' => 'textfield',
    '#autocomplete_path' => 'admin/ajax/visualshortcodes/icons_autocomplete/all',
    '#default_value' => isset($attrs['icon']) ? $attrs['icon'] : '',
    '#attributes' => ['class' => ['form-control']],
    '#prefix' => '</div><div class = "col-sm-4">',
  ];
  $form['link_text'] = [
    '#type' => 'textfield',
    '#title' => t('Read More text'),
    '#default_value' => isset($attrs['link_text']) ? $attrs['link_text'] : '',
    '#attributes' => ['class' => ['form-control']],
    '#states' => [
      'visible' => [
        '.type-icon-select' => ['value' => 'center_big'],
      ],
    ],
    '#prefix' => '</div><div class = "col-sm-6">',
    '#suffix' => '</div></div>',
  ];
  $form['inner_animation'] = [
    '#type' => 'select',
    '#title' => t('Content Animation'),
    '#options' => _visualshortcodes_list_animations(),
    '#default_value' => isset($attrs['inner_animation']) ? $attrs['inner_animation'] : '',
    '#prefix' => '<div class = "row"><div class = "col-xs-6 centered">',
    '#attributes' => ['class' => ['form-control']],
  ];
  $form['inner_icon_animation'] = [
    '#type' => 'select',
    '#title' => t('Icon Animation'),
    '#options' => _visualshortcodes_list_animations(),
    '#default_value' => isset($attrs['inner_icon_animation']) ? $attrs['inner_icon_animation'] : '',
    '#prefix' => '</div><div class = "col-xs-6 centered">',
    '#suffix' => '</div></div>',
    '#attributes' => ['class' => ['form-control']],
  ];
  return $form;
}

function shortcode_bootstrap_socialbox($attrs, $text) {
  $attrs['class'] = (isset($attrs['class']) ? $attrs['class'] : '') . 'sbtnf sbtnf-rounded color color-hover ' . $attrs['icon'];
  $link = strpos($attrs['link'], '#') === FALSE ? url($attrs['link']) : $attrs['link'];
  $text = '<span class = "social"><a target="_blank" href="' . $link . '" ' . _shortcode_bootstrap_attributes($attrs) . '></a></span>';
  drupal_add_css(drupal_get_path('module', 'shortcode_bootstrap') . '/css/social-icons.css');
  return $text;
}

function shortcode_bootstrap_socialbox_tip($format, $long) {
  $output = [];
  $output[] = '<p><strong>Social Icon Box:</strong><br/>[social_box icon = "icon-facebook" link = "http://facebook.com"][/social_box]</br>';
  $output[] = 'Available icons: <a href = "http://shalinguyen.github.io/socialicious/">http://shalinguyen.github.io/socialicious/</a></p>';
  return implode(' ', $output);
}

function shortcode_bootstrap_socialbox_settings($attrs, $text) {
  $form['icon'] = [
    '#title' => t('Icon'),
    '#type' => 'textfield',
    '#autocomplete_path' => 'admin/ajax/shortcode_boostrap/socialbox_autocomplete',
    '#default_value' => isset($attrs['icon']) ? $attrs['icon'] : '',
    '#attributes' => ['class' => ['form-control']],
    '#prefix' => '<div class = "row"><div class = "col-sm-6">',
  ];
  $form['link'] = [
    '#type' => 'textfield',
    '#title' => t('Link'),
    '#default_value' => isset($attrs['link']) ? $attrs['link'] : '',
    '#attributes' => ['class' => ['form-control']],
    '#prefix' => '</div><div class = "col-sm-6">',
    '#suffix' => '</div></div>',
  ];
  return $form;
}

function shortcode_bootstrap_pricing_table($attrs, $text) {
  $attrs['class'] = isset($attrs['class']) ? $attrs['class'] . ' ' : '';
  $colors = [
    'default' => 'package',
    'orange' => 'pricing pricing-warning',
    'red' => 'pricing-error pricing',
    'green' => 'pricing-success pricing',
    'blue' => 'pricing-info pricing',
  ];
  $btn_colors = [
    'default' => 'default',
    'orange' => 'warning',
    'red' => 'error',
    'green' => 'success',
    'blue' => 'info',
  ];
  $attrs['class'] .= isset($attrs['color']) && isset($colors[$attrs['color']]) ? $colors[$attrs['color']] : '';
  $link = isset($attrs['link']) ? (strpos($attrs['link'], '#') === FALSE ? url($attrs['link']) : $attrs['link']) : '#';
  $read_more_link = isset($attrs['read_more_link']) ? (strpos($attrs['read_more_link'], '#') === FALSE ? url($attrs['read_more_link']) : $attrs['read_more_link']) : $link;
  $icon_colors = [
    'orange' => '#1e1e1e',
    'red' => '#de2a61',
    'green' => '#9ab71a',
    'blue' => '#35beeb',
  ];
  $icon_color = isset($attrs['color']) && isset($icon_colors[$attrs['color']]) ? $icon_colors[$attrs['color']] : '#f89406';
  $stars = '';
  if (isset($attrs['stars']) && (int) $attrs['stars'] <= 5) {
    $stars = '<div class="rating-box">
      <div style="width: ' . (20 * $attrs['stars']) . '%" class="rating">
        <svg xmlns="http://www.w3.org/2000/svg" xmlns:xlink="http://www.w3.org/1999/xlink" x="0px" y="0px" width="73px" height="12px" viewBox="0 0 73 12" enable-fwb-bg="new 0 0 73 12" xml:space="preserve">
            <polygon fill-rule="evenodd" clip-rule="evenodd" fill="#1e1e1e" points="6.5,0 8,5 13,5 9,7.7 10,12 6.5,9.2 3,12 4,7.7 0,5 5,5"></polygon>
            <polygon fill-rule="evenodd" clip-rule="evenodd" fill="#1e1e1e" points="66.5,0 68,5 73,5 69,7.7 70,12 66.5,9.2 63,12 64,7.7 60,5 65,5 "></polygon>
            <polygon fill-rule="evenodd" clip-rule="evenodd" fill="#1e1e1e" points="21.5,0 23,5 28,5 24,7.7 25,12 21.5,9.2 18,12 19,7.7 15,5 20,5 "></polygon>
            <polygon fill-rule="evenodd" clip-rule="evenodd" fill="#1e1e1e" points="51.5,0 53,5 58,5 54,7.7 55,12 51.5,9.2 48,12 49,7.7 45,5 50,5 "></polygon>
            <polygon fill-rule="evenodd" clip-rule="evenodd" fill="#1e1e1e" points="36.5,0 38,5 43,5 39,7.7 40,12 36.5,9.2 33,12 34,7.7 30,5 35,5 "></polygon>
        </svg>
      </div>
    </div>';
  }
  $pricing_table_rows = $text;
  $pricing_table_rows = !empty($pricing_table_rows) ? '<ul class="options">' . $pricing_table_rows . '</ul>' : '';
  $text = '<div ' . _shortcode_bootstrap_attributes($attrs) . '>
    <div class="title"><a href="' . $link . '">' . $attrs['title'] . '</a></div>
    <div class="price-box">' .
    (isset($attrs['livicon']) ? '
      <div class="icon pull-right border ' . (isset($attrs['color']) && $attrs['color'] == 'default' ? 'bg-white rounded' : 'circle') . '">
        <span class="livicon" data-n="' . $attrs['livicon'] . '" data-s="' . (isset($attrs['color']) && $attrs['color'] == 'default' ? 62 : 32) . '" data-c="' . $icon_color . '" data-hc="0"></span>
      </div>' : '') .
    (isset($attrs['description']) ? '<div class="description">' . $attrs['description'] . '</div>' : '') .
    (isset($attrs['price_top_text']) ? '<div class="starting">' . $attrs['price_top_text'] . '</div>' : '') . '
      <div class="price">' . $attrs['price'] . (isset($attrs['price_text']) ? '<span>' . $attrs['price_text'] . '</span>' : '') . '</div>
    </div>
    ' . $pricing_table_rows . '
    <div class="bottom-box">
      ' . (isset($attrs['read_more']) ? '<a href="' . $read_more_link . '" class="more">' . $attrs['read_more'] . ' <span class="fa fa-angle-right"></span></a>' : '') . '
      ' . $stars .
    (isset($attrs['button']) ? '<a href="' . $link . '" class="btn btn-lg ' . (isset($attrs['color']) ? 'btn-' . $btn_colors[$attrs['color']] : 'btn-default') . ' clearfix">' . $attrs['button'] . '</a>' : '') . '
    </div>
  </div>';
  if (!empty($attrs['livicon'])) {
    if (!empty(libraries_get_path('raphael'))) {
      drupal_add_js(libraries_get_path('raphael') . '/raphael.min.js');
    }
    else {
      drupal_add_js(shortcode_bootstrap_cdn('raphael'), 'external');
    }
    drupal_add_js(drupal_get_path('module', 'shortcode_bootstrap') . '/js/livicons.js');

  }
  return $text;
}

function shortcode_bootstrap_pricing_table_tip($format, $long) {
  $output = [];
  $output[] = '<p><strong>Pricing Table:</strong><br/>[pricing_table title = "Basic" price = "19" price_top_text = "Starting at" price_text = "/month" link = "shop" button = "Buy Now" livicon = "" stars = 3 color = "green" read_more = "Read More"]<br/>
  &nbsp;[pricing_table_row disabled check]Text[/pricing_table_row]<br/>
  [/pricing_table]</br>';
  $output[] = 'Available variables: <strong>title</strong>, <strong>price</strong>, <strong>price_text</strong>, <strong>price_top_text</strong>, <strong>button</strong>, <strong>link</strong>, <strong>color</strong>, <strong>stars</strong>, <strong>read_more</strong>.<br/>';
  return implode(' ', $output);
}

function shortcode_bootstrap_pricing_table_settings($attrs, $text) {
  $form['title'] = [
    '#type' => 'textfield',
    '#title' => t('Title'),
    '#default_value' => isset($attrs['title']) ? $attrs['title'] : '',
    '#attributes' => ['class' => ['form-control']],
    '#prefix' => '<div class = "row"><div class = "col-sm-8">',
  ];
  $colors = [
    'orange' => t('Orange'),
    'red' => t('Red'),
    'green' => t('Green'),
    'blue' => t('Blue'),
    'default' => t('Default'),
  ];
  $form['color'] = [
    '#type' => 'radios',
    '#title' => t('Color'),
    '#options' => $colors,
    '#default_value' => isset($attrs['color']) ? $attrs['color'] : 'orange',
    '#attributes' => ['class' => ['color-radios']],
    '#prefix' => '</div><div class = "col-sm-4">',
    '#suffix' => '</div></div>',
  ];
  $form['description'] = [
    '#type' => 'textarea',
    '#rows' => 3,
    '#title' => t('Short Description'),
    '#default_value' => isset($attrs['description']) ? $attrs['description'] : '',
    '#attributes' => ['class' => ['form-control']],
  ];
  $form['price_top_text'] = [
    '#type' => 'textfield',
    '#title' => t('Price Top Text'),
    '#default_value' => isset($attrs['price_top_text']) ? $attrs['price_top_text'] : '',
    '#attributes' => ['class' => ['form-control']],
    '#prefix' => '<div class = "row"><div class = "col-sm-4">',
  ];
  $form['price'] = [
    '#type' => 'textfield',
    '#title' => t('Price'),
    '#default_value' => isset($attrs['price']) ? $attrs['price'] : '',
    '#attributes' => ['class' => ['form-control']],
    '#prefix' => '</div><div class = "col-sm-4">',
  ];
  $form['price_text'] = [
    '#type' => 'textfield',
    '#title' => t('Price small text'),
    '#default_value' => isset($attrs['price_text']) ? $attrs['price_text'] : '',
    '#attributes' => ['class' => ['form-control']],
    '#prefix' => '</div><div class = "col-sm-4">',
    '#suffix' => '</div></div>',
  ];
  $stars = ['', 0, 0.5, 1, 1.5, 2, 2.5, 3, 3.5, 4, 4.5, 5];
  $form['stars'] = [
    '#type' => 'select',
    '#title' => t('Stars'),
    '#options' => array_combine($stars, $stars),
    '#default_value' => isset($attrs['stars']) ? $attrs['stars'] : '',
    '#attributes' => ['class' => ['form-control']],
    '#prefix' => '<div class = "row"><div class = "col-sm-6">',
  ];
  $form['livicon'] = [
    '#type' => 'textfield',
    '#title' => t('LivIcon'),
    '#autocomplete_path' => 'ajax/visualshortcodes/icons_autocomplete/all',
    '#default_value' => isset($attrs['livicon']) ? $attrs['livicon'] : '',
    '#attributes' => ['class' => ['form-control']],
    '#prefix' => '</div><div class = "col-sm-6">',
    '#suffix' => '</div></div>',
  ];
  $form['button'] = [
    '#type' => 'textfield',
    '#title' => t('Button text'),
    '#default_value' => isset($attrs['button']) ? $attrs['button'] : '',
    '#attributes' => ['class' => ['form-control']],
    '#prefix' => '<div class = "row"><div class = "col-sm-6">',
  ];
  $form['link'] = [
    '#type' => 'textfield',
    '#title' => t('Link'),
    '#default_value' => isset($attrs['link']) ? $attrs['link'] : '',
    '#attributes' => ['class' => ['form-control']],
    '#prefix' => '</div><div class = "col-sm-6">',
    '#suffix' => '</div></div>',
  ];
  $form['read_more'] = [
    '#type' => 'textfield',
    '#title' => t('Read More text'),
    '#default_value' => isset($attrs['read_more']) ? $attrs['read_more'] : '',
    '#attributes' => ['class' => ['form-control']],
    '#prefix' => '<div class = "row"><div class = "col-sm-6">',
  ];
  $form['read_more_link'] = [
    '#type' => 'textfield',
    '#title' => t('Read More link'),
    '#default_value' => isset($attrs['read_more_link']) ? $attrs['read_more_link'] : '',
    '#attributes' => ['class' => ['form-control']],
    '#prefix' => '</div><div class = "col-sm-6">',
    '#suffix' => '</div></div>',
  ];
  return $form;
}

function shortcode_bootstrap_pricing_table_row($attrs, $text) {
  $attrs['dis'] = isset($attrs['disabled']) ? $attrs['disabled'] : (isset($attrs['dis']) ? $attrs['dis'] : 0);
  $attrs['class'] = (isset($attrs['class']) ? $attrs['class'] : '') . ($attrs['dis'] ? '' : 'active');
  $checked = isset($attrs['check']) && $attrs['check'] ? '<span><i class="fa fa-check"></i></span>' : '';
  $title = isset($attrs['title']) ? $attrs['title'] : '';
  return '<li ' . _shortcode_bootstrap_attributes($attrs) . '>' . $checked . $title . $text . '</li>';
}

function shortcode_bootstrap_pricing_table_row_settings($attrs, $text) {
  $form['title'] = [
    '#type' => 'textfield',
    '#title' => t('Title'),
    '#default_value' => isset($attrs['title']) ? $attrs['title'] : '',
    '#attributes' => ['class' => ['form-control']],
    '#description' => t('You can also insert in this shortcode any other shortcode'),
  ];
  $attrs['dis'] = isset($attrs['disabled']) ? $attrs['disabled'] : (isset($attrs['dis']) ? $attrs['dis'] : 0);
  $form['dis'] = [
    '#type' => 'checkbox',
    '#title' => t('Disabled'),
    '#default_value' => $attrs['dis'],
  ];
  $form['check'] = [
    '#type' => 'checkbox',
    '#title' => t('Check icon'),
    '#default_value' => isset($attrs['check']) ? $attrs['check'] : 0,
  ];
  return $form;
}

function shortcode_bootstrap_view($attrs, $text) {
  $attrs['class'] = isset($attrs['class']) ? $attrs['class'] : '';
  $view = '';
  if (strpos($attrs['admin_url'], 'admin/structure/views/view') !== FALSE) {
    $view_name = substr($attrs['admin_url'], strpos($attrs['admin_url'], 'view/') + 5);
    $parts = explode('/', $view_name);
    $view_name = $parts[0];
    $view = isset($parts[2]) ? views_embed_view($view_name, $parts[2]) : views_embed_view($view_name);
  }
  $text = '<div ' . _shortcode_bootstrap_attributes($attrs) . '>' . $view . '</div>';
  return $text;
}

function shortcode_bootstrap_view_settings($attrs, $text) {
  $views = views_get_all_views();
  $displays = [];
  foreach ($views as $view) {
    foreach ($view->display as $display) {
      if ($display->display_title != 'Master') {
        $displays['admin/structure/views/view/' . $view->name . '/edit/' . $display->id] = check_plain($view->human_name . ': ' . $display->display_title);
      }
    }
  }
  $form['admin_url'] = [
    '#title' => t('View'),
    '#type' => 'select',
    '#options' => $displays,
    '#default_value' => isset($attrs['admin_url']) ? $attrs['admin_url'] : '',
    '#attributes' => ['class' => ['form-control']],
  ];
  return $form;
}

function shortcode_bootstrap_view_description($attrs, $text) {
  if (strpos($attrs['admin_url'], 'admin/structure/views/view') !== FALSE) {
    $form = shortcode_bootstrap_view_settings($attrs, $text);
    $value = l($form['admin_url']['#options'][$attrs['admin_url']], $attrs['admin_url'], ['attributes' => ['target' => '_blank']]);
    return $value;
  }
}

function shortcode_bootstrap_block($attrs, $text) {
  if (strpos($attrs['admin_url'], 'admin/structure/block') !== FALSE) {
    $block_name = substr($attrs['admin_url'], strpos($attrs['admin_url'], '/manage/') + 8);
    $parts = explode('/', $block_name);
    $block = _shortcode_bootstrap_render_block($parts[0], $parts[1]);
    $block = render($block);
  }
  $attrs_output = _shortcode_bootstrap_attributes($attrs);
  $text = $attrs_output ? '<div ' . $attrs_output . '>' . $block . '</div>' : $block;
  return $text;
}

function shortcode_bootstrap_block_tip($format, $long) {
  $output = [];
  $output[] = '<p><strong>Block:</strong><br/>[block admin_url = "admin/structure/block/manage/progressive_cms/gmap/configure"][/block]</br>';
  $output[] = '<strong>admin_url</strong> - URL of the block edit page.</p>';
  return implode(' ', $output);
}

function shortcode_bootstrap_block_settings($attrs, $text) {
  module_load_include('inc', 'block', 'block.admin');
  $current_theme = variable_get('theme_default', 'none');
  $blocks = block_admin_display_prepare_blocks($current_theme);
  usort($blocks, '_sort_blocks');
  $options = [];
  foreach ($blocks as $block) {
    $options['admin/structure/block/manage/' . $block['module'] . '/' . $block['delta'] . '/configure'] = check_plain($block['info']);
  }
  asort($options);
  $form['admin_url'] = [
    '#title' => t('Block'),
    '#type' => 'select',
    '#options' => $options,
    '#default_value' => isset($attrs['admin_url']) ? $attrs['admin_url'] : '',
    '#attributes' => ['class' => ['form-control']],
  ];
  return $form;
}

function _sort_blocks($a, $b) {
  return $a['info'] > $b['info'];
}

function shortcode_bootstrap_block_description($attrs, $text) {
  if (strpos($attrs['admin_url'], 'admin/structure/block') !== FALSE) {
    $form = shortcode_bootstrap_block_settings($attrs, $text);
    $value = l($form['admin_url']['#options'][$attrs['admin_url']], $attrs['admin_url'], ['attributes' => ['target' => '_blank']]);
    return $value;
  }
}

function shortcode_bootstrap_node($attrs, $text) {
  if (isset($attrs['admin_url']) && strpos($attrs['admin_url'], 'node/') !== FALSE) {
    $node_name = substr($attrs['admin_url'], strpos($attrs['admin_url'], 'node/') + 5);
    $parts = explode('/', $node_name);
    $node = node_load($parts[0]);
    if ($node && $node->nid) {
      $node = node_view($node);
      $output = render($node);
      $attrs = _shortcode_bootstrap_attributes($attrs);
      $text = $attrs ? '<div ' . $attrs . '>' . $output . '</div>' : $output;
      return $text;
    }
  }
}

function shortcode_bootstrap_node_tip($format, $long) {
  $output = [];
  $output[] = '<p><strong>Node:</strong><br/>[node admin_url = "node/1/edit"][/node]</br>';
  $output[] = '<strong>admin_url</strong> - URL of the node edit page.</p>';
  return implode(' ', $output);
}

function shortcode_bootstrap_node_description($attrs, $text) {
  if (strpos($attrs['admin_url'], 'node/') !== FALSE) {
    $node_name = substr($attrs['admin_url'], strpos($attrs['admin_url'], 'node/') + 5);
    $parts = explode('/', $node_name);
    $nid = $parts[0];
    if (is_numeric($nid)) {
      $node = node_load($nid);
      return l($node->title, 'node/' . $nid . '/edit', ['attributes' => ['target' => '_blank']]);
    }
  }
}

function shortcode_bootstrap_node_settings($attrs, $text) {
  $form['admin_url'] = [
    '#title' => t('Node Title'),
    '#type' => 'textfield',
    '#autocomplete_path' => 'admin/ajax/visualshortcodes/node_autocomplete',
    '#default_value' => isset($attrs['admin_url']) ? $attrs['admin_url'] : '',
    '#attributes' => ['class' => ['form-control']],
  ];
  return $form;
}

function shortcode_bootstrap_quicklinks($attrs, $text) {
  if (isset($attrs['machine_name']) && $attrs['machine_name']) {
    $menu_tree = menu_tree_all_data($attrs['machine_name']);
    return '<div class = "sidebar"><nav class = "menu">' . _shortcode_bootstrap_quicklinks($menu_tree) . '</nav></div>';
  }
  return '';
}

function _shortcode_bootstrap_quicklinks($items, $class = '') {
  $output = '<ul ' . ($class ? 'class = "' . $class . '"' : '') . '>';
  foreach ($items as $item) {
    $class = !empty($item['below']) ? 'class = "parent' . ($item['link']['expanded'] ? ' active' : '') . '"' : '';
    $title = !empty($item['below']) ? '<span class="open-sub"></span>' : '';
    $output .= '<li ' . $class . '>' . l($title . t($item['link']['link_title']), $item['link']['link_path'], ['html' => TRUE]);
    if (!empty($item['below'])) {
      $output .= _shortcode_bootstrap_quicklinks($item['below'], 'sub');
    }
    $output .= '</li>';
  }
  return $output . '</ul>';
}

function shortcode_bootstrap_quicklinks_tip($format, $long) {
  $output = [];
  $output[] = '<p><strong>Quick Links:</strong><br/>[quicklinks machine_name = "menu-quick-links"][/quicklinks]</br>';
  return implode(' ', $output);
}

function shortcode_bootstrap_quicklinks_settings($attrs, $text) {
  $menus = db_select('menu_custom', 'm')
    ->fields('m', ['menu_name', 'title'])
    ->orderBy('m.title')
    ->execute()
    ->fetchAllKeyed(0, 1);
  $form['machine_name'] = [
    '#title' => t('Menu'),
    '#type' => 'select',
    '#options' => $menus,
    '#default_value' => isset($attrs['machine_name']) ? $attrs['machine_name'] : '',
    '#attributes' => ['class' => ['form-control']],
  ];
  return $form;
}

function shortcode_bootstrap_container($attrs, $text) {
  $attrs['class'] = 'container ' . (isset($attrs['class']) ? $attrs['class'] : '');
  $text = '<div ' . _shortcode_bootstrap_attributes($attrs) . '>' . $text . '</div>';
  return $text;
}

function shortcode_bootstrap_container_tip($format, $long) {
  $output = [];
  $output[] = '<p><strong>Responsive container:</strong><br/>[container]Content[/container]</br>';
  $output[] = 'Use this for non-full width content.</p>';
  $output[] = '<p><strong>Responsive columns:</strong><br/>[row]<br/>[col phone = 12 tablet = 12 desktop = 6 wide = 6]Content with date[/col][/row]</br>';
  $output[] = 'Describe how many rows will take col in different devices: phone, tablet, desktop, wide. From 1 to 12 rows.</p>';
  return implode(' ', $output);
}

function shortcode_bootstrap_row($attrs, $text) {
  $attrs['class'] = 'row ' . (isset($attrs['class']) ? $attrs['class'] : '');
  $text = '<div ' . _shortcode_bootstrap_attributes($attrs) . '>' . $text . '</div>';
  return $text;
}

function shortcode_bootstrap_col($attrs, $text) {
  $attrs['class'] = isset($attrs['class']) ? $attrs['class'] : '';
  if (isset($attrs['phone'])) {
    $attrs['class'] .= ' col-xs-' . $attrs['phone'];
  }
  if (isset($attrs['tablet'])) {
    $attrs['class'] .= ' col-sm-' . $attrs['tablet'];
  }
  if (isset($attrs['desktop'])) {
    $attrs['class'] .= ' col-md-' . $attrs['desktop'];
  }
  if (isset($attrs['wide'])) {
    $attrs['class'] .= ' col-lg-' . $attrs['wide'];
  }
  $text = '<div ' . _shortcode_bootstrap_attributes($attrs) . '>' . $text . '</div>';
  return $text;
}

function shortcode_bootstrap_message($attrs, $text) {
  $attrs['class'] = 'alert ' . (isset($attrs['extra_class']) ? $attrs['extra_class'] : '');
  $attrs['class'] .= isset($attrs['dismissable']) && $attrs['dismissable'] ? ' fade in' : '';
  $attrs['class'] .= isset($attrs['color']) && $attrs['color'] ? ' ' . $attrs['color'] : '';
  $attrs['class'] .= isset($attrs['center']) && $attrs['center'] ? ' text-center' : '';
  $attrs['class'] .= isset($attrs['type']) && $attrs['type'] == 'border' ? ' alert-border alert-dismissable' : '';
  if (isset($attrs['type']) && $attrs['type'] == 'border' && isset($attrs['color_type']) && $attrs['color_type'] && $attrs['custom_color']) {
    $attrs['style_border_color'] = '#' . trim($attrs['custom_color'], '#');
  }
  $icon = isset($attrs['icon']) && $attrs['icon'] ? '<i class="' . $attrs['icon'] . ' alert-icon"></i>' : '';
  $text = (isset($attrs['dismissable']) && $attrs['dismissable'] ? '<button type="button" class="close" data-dismiss="alert" aria-hidden="true">×</button>' : '') . $text;
  $text = '<div ' . _shortcode_bootstrap_attributes($attrs) . '>' . $icon . $text . '</div>';
  return $text;
}

function shortcode_bootstrap_message_tip($format, $long) {
  $output = [];
  $output[] = '<p><strong>Message box:</strong><br/>[message][/message]</br>';
  $output[] = 'Available classes: alert-danger, alert-info, alert-warning, alert-success, alert-dismissable.</p>';
  return implode(' ', $output);
}

function shortcode_bootstrap_message_settings($attrs, $text) {
  $form['color_type'] = [
    '#title' => t('Custom Color'),
    '#type' => 'checkbox',
    '#default_value' => isset($attrs['color_type']) ? $attrs['color_type'] : FALSE,
    '#attributes' => ['class' => ['color-type-select']],
    '#prefix' => '<div class = "row"><div class = "col-sm-6">',
  ];
  $colors = [
    'grey' => t('Grey'),
    'alert-black' => t('Black'),
    'alert-danger' => t('Red'),
    'alert-info' => t('Blue'),
    'alert-warning' => t('Orange'),
    'alert-success' => t('Green'),
    'alert-primary' => t('Dark Blue'),
  ];
  $form['color'] = [
    '#type' => 'radios',
    '#title' => t('Color'),
    '#options' => $colors,
    '#default_value' => isset($attrs['color']) ? $attrs['color'] : '',
    '#attributes' => ['class' => ['color-radios']],
    '#states' => [
      'visible' => [
        '.color-type-select' => ['checked' => FALSE],
      ],
    ],
  ];
  $form['custom_color'] = [
    '#type' => 'textfield',
    '#title' => t('Color'),
    '#default_value' => isset($attrs['custom_color']) ? $attrs['custom_color'] : '',
    '#states' => [
      'visible' => [
        '.color-type-select' => ['checked' => TRUE],
      ],
    ],
    '#attributes' => ['class' => ['form-control colorpicker-enable']],
  ];
  $form['dismissable'] = [
    '#type' => 'checkbox',
    '#title' => t('Dismissable'),
    '#default_value' => isset($attrs['dismissable']) ? $attrs['dismissable'] : TRUE,
    '#prefix' => '</div><div class = "col-sm-6">',
  ];
  $form['icon'] = [
    '#title' => t('Icon'),
    '#type' => 'textfield',
    '#autocomplete_path' => 'admin/ajax/visualshortcodes/icons_autocomplete/all',
    '#default_value' => isset($attrs['icon']) ? $attrs['icon'] : '',
    '#attributes' => ['class' => ['form-control']],
    '#prefix' => '</div><div class = "col-sm-6">',
    '#suffix' => '</div></div>',
  ];
  $options = ['background' => t('Background'), 'border' => t('Border')];
  $form['type'] = [
    '#title' => t('Colored'),
    '#type' => 'select',
    '#options' => $options,
    '#default_value' => isset($attrs['type']) ? $attrs['type'] : '',
    '#attributes' => ['class' => ['form-control']],
    '#prefix' => '<div class = "row"><div class = "col-sm-6">',
  ];
  $form['center'] = [
    '#title' => t('Center Align'),
    '#type' => 'checkbox',
    '#default_value' => isset($attrs['center']) ? $attrs['center'] : FALSE,
    '#prefix' => '</div><div class = "col-sm-6">',
    '#suffix' => '</div></div>',
  ];
  return $form;
}

function shortcode_bootstrap_button($attrs, $text) {
  $attrs['extra_classes'] = isset($attrs['extra_classes']) ? $attrs['extra_classes'] : '';
  $attrs['extra_classes'] .= isset($attrs['color']) && (!isset($attrs['color_type']) || !$attrs['color_type']) ? ' ' . $attrs['color'] : '';
  $attrs['extra_classes'] .= isset($attrs['size']) ? ' ' . $attrs['size'] : '';
  $attrs['type'] = isset($attrs['type']) ? $attrs['type'] : 'default';
  $styles = [
    'default' => 'btn',
    'outlined' => 'btn btn-border',
    'social_squared' => 'sbtnf sbtnf-squere sbtnf-icon-white sbtnf-icon-bg-black color',
    'social_rounded' => 'sbtnf sbtnf-rounded sbtnf-icon-white sbtnf-icon-bg-black color',
    'social_heavily_rounded' => 'sbtnf sbtnf-circle sbtnf-icon-white sbtnf-icon-bg-black color',
    'block' => 'btn btn-block',
  ];
  $attrs['extra_classes'] .= ' ' . $styles[$attrs['type']];
  if (isset($attrs['color_type']) && $attrs['color_type'] && isset($attrs['custom_color']) && $attrs['custom_color']) {
    $attrs['style_background_color'] = trim($attrs['custom_color'], '#');
    if (strtolower($attrs['style_background_color']) == 'ffffff') {
      $attrs['extra_classes'] .= ' btn-white';
    }
  }
  if (in_array($attrs['type'], [
    'social_squared',
    'social_rounded',
    'social_heavily_rounded',
  ])) {
    drupal_add_css(drupal_get_path('module', 'shortcode_bootstrap') . '/css/social-icons.css');
  }
  $attrs['link'] = isset($attrs['link']) ? $attrs['link'] : '#';
  $attrs['href'] = strpos($attrs['link'], '#') === FALSE ? url($attrs['link']) : $attrs['link'];
  $attrs['target'] = isset($attrs['new_tab']) && $attrs['new_tab'] ? '_blank' : '';
  $text .= isset($attrs['text']) ? $attrs['text'] : '';
  $text = isset($attrs['icon']) ? '<i class = "' . $attrs['icon'] . '"></i>&nbsp; ' . $text : $text;
  $text = '<a ' . _shortcode_bootstrap_attributes($attrs) . '>' . $text . '</a>';
  drupal_add_css(drupal_get_path('module', 'shortcode_bootstrap') . '/css/buttons.css');
  return $text;
}

function shortcode_bootstrap_button_tip($format, $long) {
  $output = [];
  $output[] = '<p><strong>Button Link:</strong><br/>[button class="btn-lg btn-default" link = "contact"]Text[/button]</br>';
  $output[] = '<strong>link</strong> - URL to linked content.</br>';
  $output[] = 'Available size classes: <strong>btn-lg</strong> - Big, <strong>btn-sm</strong> - Small, by default - Medium.</br>';
  $output[] = 'Available color classes: <strong>btn-default</strong>, <strong>btn-primary</strong>, <strong>btn-info</strong>, <strong>btn-success</strong>, <strong>btn-warning</strong>, <strong>btn-danger</strong></p>';
  return implode(' ', $output);
}

function shortcode_bootstrap_button_settings($attrs, $text) {
  $form['icon'] = [
    '#title' => t('Icon'),
    '#type' => 'textfield',
    '#autocomplete_path' => 'admin/ajax/visualshortcodes/icons_autocomplete/all',
    '#default_value' => isset($attrs['icon']) ? $attrs['icon'] : '',
    '#attributes' => ['class' => ['form-control']],
    '#prefix' => '<div class = "row"><div class = "col-sm-6">',
  ];
  $styles = [
    'default' => t('Default'),
    'outlined' => t('Outlined'),
    'social_squared' => t('Social Squared'),
    'social_rounded' => t('Social Smoothly Rounded'),
    'social_heavily_rounded' => t('Social Heavily Rounded'),
    'block' => t('Block button'),
  ];
  $form['type'] = [
    '#type' => 'select',
    '#title' => t('Style'),
    '#options' => $styles,
    '#default_value' => isset($attrs['type']) ? $attrs['type'] : '',
    '#attributes' => ['class' => ['form-control']],
    '#prefix' => '</div><div class = "col-sm-6">',
    '#suffix' => '</div></div>',
  ];
  $form['color_type'] = [
    '#title' => t('Custom Color'),
    '#type' => 'checkbox',
    '#default_value' => isset($attrs['color_type']) ? $attrs['color_type'] : FALSE,
    '#attributes' => ['class' => ['color-type-select']],
    '#prefix' => '<div class = "row"><div class = "col-sm-6">',
  ];
  $colors = [
    'btn-default' => t('Grey'),
    'btn-danger' => t('Red'),
    'btn-info' => t('Blue'),
    'btn-warning' => t('Orange'),
    'btn-success' => t('Green'),
    'btn-primary' => t('Dark Blue'),
    'btn-inverse' => t('Inverse'),
  ];
  $form['color'] = [
    '#type' => 'radios',
    '#title' => t('Color'),
    '#options' => $colors,
    '#default_value' => isset($attrs['color']) ? $attrs['color'] : 'btn-info',
    '#attributes' => ['class' => ['color-radios']],
    '#states' => [
      'visible' => [
        '.color-type-select' => ['checked' => FALSE],
      ],
    ],
  ];
  $form['custom_color'] = [
    '#type' => 'textfield',
    '#title' => t('Color'),
    '#default_value' => isset($attrs['custom_color']) ? $attrs['custom_color'] : '',
    '#states' => [
      'visible' => [
        '.color-type-select' => ['checked' => TRUE],
      ],
    ],
    '#attributes' => ['class' => ['form-control colorpicker-enable']],
  ];
  $sizes = [
    'btn-xs' => t('Small'),
    'btn-sm' => t('Medium'),
    '' => t('Default'),
    'btn-lg' => t('Large'),
  ];
  $form['size'] = [
    '#type' => 'select',
    '#title' => t('Size'),
    '#options' => $sizes,
    '#default_value' => isset($attrs['size']) ? $attrs['size'] : '',
    '#attributes' => ['class' => ['form-control']],
    '#prefix' => '</div><div class = "col-sm-6">',
    '#suffix' => '</div></div>',
  ];
  $form['text'] = [
    '#title' => t('Text'),
    '#type' => 'textfield',
    '#default_value' => isset($attrs['text']) ? $attrs['text'] : '',
    '#attributes' => ['class' => ['form-control']],
    '#prefix' => '<div class = "row"><div class = "col-sm-6">',
  ];
  $form['link'] = [
    '#type' => 'textfield',
    '#title' => t('Link'),
    '#default_value' => isset($attrs['link']) ? $attrs['link'] : '',
    '#attributes' => ['class' => ['form-control']],
    '#prefix' => '</div><div class = "col-sm-6">',
    '#suffix' => '</div></div>',
  ];
  $form['new_tab'] = [
    '#title' => t('Open link in new tab'),
    '#type' => 'checkbox',
    '#default_value' => isset($attrs['new_tab']) ? $attrs['new_tab'] : FALSE,
    '#prefix' => '<div class = "row"><div class = "col-sm-6">',
    '#suffix' => '</div></div>',
  ];
  return $form;
}

function shortcode_bootstrap_accordions($attrs, $text) {
  global $accordion_id, $accordion_filter;
  $attrs['class'] = 'panel-group ' . (isset($attrs['class']) ? ' ' . $attrs['class'] : '');
  $attrs['class'] .= isset($attrs['multi_collapse']) ? ' multi-collapse' : '';
  if (!empty($accordion_filter)) {
    $attrs['class'] .= ' filter-elements';
  }
  $text = '<div ' . _shortcode_bootstrap_attributes($attrs) . ' id = "accordion' . $accordion_id . '">' . $text . '</div>';
  if (!empty($accordion_filter)) {
    $output = '<div class="filter-box accordions-filter">
      <div class="btn-group filter-buttons filter-list">
        <button type="button" class="dropdown-toggle" data-toggle="dropdown">
          ' . t('All') . ' <span class="caret"></span>
        </button>
        <ul class="dropdown-menu" role="menu">
          <li><a href="#" data-filter="*" class="active">' . t('All') . '</a></li>';
    foreach ($accordion_filter as $plain => $title) {
      $output .= '<li><a href="#" data-filter=".' . $plain . '">' . $title . '</a></li>';
    }
    $output .= '     
        </ul>
        <div class="clearfix"></div>
      </div>';
    $text = $output . $text . '</div>';
  }
  $accordion_id++;
  $accordion_filter = [];
  return $text;
}

function shortcode_bootstrap_accordions_settings($attrs, $text) {
  $form['multi_collapse'] = [
    '#type' => 'checkbox',
    '#title' => t('Multi Collapse mode'),
    '#default_value' => isset($attrs['multi_collapse']) ? $attrs['multi_collapse'] : '',
  ];
  return $form;
}

function shortcode_bootstrap_accordions_tip($format, $long) {
  $output = [];
  $output[] = '<p><strong>Accordion:</strong><br/>[accordions]<br/>&nbsp;&nbsp;[accordion title = "Accordion Panel #1" active]Text[/accordion]<br/>[/accordions]';
  return implode(' ', $output);
}

function shortcode_bootstrap_accordion($attrs, $text) {
  global $accordion_count, $accordion_id, $accordion_filter;
  if (empty($accordion_id)) {
    $accordion_id = rand(1, 999999);
  }
  if (!isset($accordion_filter)) {
    $accordion_filter = [];
  }
  $accordion_count = empty($accordion_count) ? rand(1, 999999) : $accordion_count + 1;
  $attrs['class'] = (isset($attrs['class']) ? $attrs['class'] . ' ' : '') . 'panel ';
  $attrs['class'] .= isset($attrs['color']) && $attrs['color'] ? $attrs['color'] : 'panel-default';
  $attrs['class'] .= isset($attrs['active']) && $attrs['active'] ? ' active' : '';
  if (isset($attrs['filter_category'])) {
    $filter_category = isset($attrs['filter_category']) ? strtolower(preg_replace('/[^\w]/', '-', $attrs['filter_category'])) : '';
    $attrs['class'] .= ' ' . $filter_category;
    $accordion_filter[$filter_category] = $attrs['filter_category'];
  }
  $text = '<div ' . _shortcode_bootstrap_attributes($attrs) . '>
    <div class="panel-heading">
      <div class="panel-title">
        <a data-toggle="collapse" data-parent="#accordion' . $accordion_id . '" href="#accordion-' . $accordion_count . '">
          ' . $attrs['title'] . '
        </a>
      </div>
    </div>
    <div id="accordion-' . $accordion_count . '" class="panel-collapse collapse' . (isset($attrs['active']) && $attrs['active'] ? ' in' : '') . '">
      <div class="panel-body">
        ' . $text . '
      </div>
    </div>
  </div>';
  return $text;
}

function shortcode_bootstrap_accordion_settings($attrs, $text) {
  $form['active'] = [
    '#title' => t('Active'),
    '#type' => 'checkbox',
    '#default_value' => isset($attrs['active']) ? $attrs['active'] : '',
  ];
  $colors = [
    'panel-default' => t('Default'),
    'panel-danger' => t('Red'),
    'panel-info' => t('Blue'),
    'panel-success' => t('Green'),
    'panel-warning' => t('Orange'),
    'panel-primary' => t('Dark Blue'),
  ];
  $form['color'] = [
    '#type' => 'radios',
    '#title' => t('Color'),
    '#options' => $colors,
    '#default_value' => isset($attrs['color']) ? $attrs['color'] : 'panel-default',
    '#attributes' => ['class' => ['color-radios']],
  ];
  $form['title'] = [
    '#type' => 'textfield',
    '#title' => t('Title'),
    '#default_value' => isset($attrs['title']) ? $attrs['title'] : '',
    '#attributes' => ['class' => ['form-control']],
  ];
  $form['filter_category'] = [
    '#type' => 'textfield',
    '#title' => t('Filter Category'),
    '#default_value' => isset($attrs['filter_category']) ? $attrs['filter_category'] : '',
    '#attributes' => ['class' => ['form-control']],
  ];

  return $form;
}

function shortcode_bootstrap_image($attrs, $text) {
  if (!is_array($attrs)) {
    $attrs = [];
  }
  $attrs['class'] = isset($attrs['class']) ? ' ' . $attrs['class'] : '';
  $attrs['class'] = ' ' . (isset($attrs['type']) && $attrs['type'] == 'title_overlay' ? 'image_overlay' : 'caption');
  $img_class = isset($attrs['img_rounded']) && $attrs['img_rounded'] ? 'class="img-rounded"' : '';
  $attrs['caption'] = isset($attrs['caption']) && $attrs['caption'] ? $attrs['caption'] : $text;
  $file = isset($attrs['fid']) && !empty($attrs['fid']) ? file_load($attrs['fid']) : $attrs['path'];
  $filename = isset($file->uri) ? file_create_url($file->uri) : $file;
  $text = '<div ' . _shortcode_bootstrap_attributes($attrs) . '>
    <img src="' . $filename . '" ' . $img_class . ' alt="' . (isset($attrs['alt']) ? $attrs['alt'] : '') . '" title="' . (isset($attrs['title']) ? $attrs['title'] : '') . '">
    ' . (!empty($attrs['caption']) ? '<div class = "description">' . $attrs['caption'] . '</div>' : '') . '
  </div>';
  return $text;
}

function shortcode_bootstrap_image_tip($format, $long) {
  $output = [];
  $output[] = '<p><strong>Image with caption:</strong><br/>[image path="image.png" caption = "Image caption" type = "title_overlay" img_rounded = 1][/image]</br>';
  return implode(' ', $output);
}

function shortcode_bootstrap_image_settings($attrs, $text) {
  if (!isset($attrs['fid']) && !$attrs['fid'] && isset($attrs['path'])) {
    $form['path'] = [
      '#type' => 'textfield',
      '#default_value' => isset($attrs['path']) ? $attrs['path'] : '',
      '#attributes' => ['class' => ['hidden']],
    ];
  }
  $filename = isset($attrs['fid']) && !empty($attrs['fid']) ? file_load($attrs['fid'])->uri : (isset($attrs['path']) ? $attrs['path'] : '');
  $image = $filename ? theme('image_style', [
    'style_name' => 'media_thumbnail',
    'path' => $filename,
  ]) : '';
  $form['fid'] = [
    '#type' => 'textfield',
    '#title' => t('Image'),
    '#default_value' => isset($attrs['fid']) ? $attrs['fid'] : '',
    '#attributes' => ['class' => ['image-media-upload hidden']],
    '#field_suffix' => '<div class = "preview-image">' . $image . '</div><a href = "#" class = "media-upload button">' . t('Upload Image') . '</a><a href = "#" class = "media-remove button">' . t('Remove Image') . '</a>',
    '#suffix' => '<div class = "clearfix"></div>',
    '#prefix' => '<div class = "row"><div class = "col-sm-6">',
  ];
  $form['img_rounded'] = [
    '#type' => 'checkbox',
    '#title' => t('Rounded Image'),
    '#default_value' => isset($attrs['img_rounded']) ? $attrs['img_rounded'] : '',
    '#prefix' => '</div><div class = "col-sm-6">',
    '#suffix' => '</div></div>',
  ];

  $form['caption'] = [
    '#type' => 'textfield',
    '#title' => t('Caption'),
    '#default_value' => isset($attrs['caption']) ? $attrs['caption'] : '',
    '#attributes' => ['class' => ['form-control']],
    '#prefix' => '<div class = "row"><div class = "col-sm-6">',
  ];
  $types = ['title_overlay' => t('Overlay'), 'caption' => t('Caption')];
  $form['type'] = [
    '#type' => 'select',
    '#title' => t('Title type'),
    '#options' => $types,
    '#default_value' => isset($attrs['type']) ? $attrs['type'] : '',
    '#attributes' => ['class' => ['form-control']],
    '#prefix' => '</div><div class = "col-sm-6">',
    '#suffix' => '</div></div>',
  ];
  return $form;
}

function shortcode_bootstrap_map($attrs, $text) {
  $attrs['class'] = 'map-box' . (isset($attrs['class']) ? ' ' . $attrs['class'] : '');

  $data = [
    'q' => $attrs['title'],
    'lat' => $attrs['lat'],
    'lng' => $attrs['lng'],
    'z' => $attrs['zoom'],
    'output' => 'embed',
    'ie' => 'UTF8',
    'iwloc' => '',
  ];

  $text = '<div ' . _shortcode_bootstrap_attributes($attrs) . '>' .
    (isset($attrs['tooltip']) && $attrs['tooltip'] == 'map_overlay' ? '<div class="contact-info col-sm-6 col-md-6" data-appear-animation="fadeInLeftBig">' . $text . '</div>' : '') .
    '<div style="height: ' . (isset($attrs['height']) ? $attrs['height'] : 276) . 'px;"
      class="map-canvas"
      data-zoom="' . (isset($attrs['zoom']) ? $attrs['zoom'] : 6) . '"
      data-lat="' . (isset($attrs['lat']) ? $attrs['lat'] : 0) . '"
      data-lng="' . (isset($attrs['lng']) ? $attrs['lng'] : 0) . '"
      ' . (isset($attrs['type']) ? 'data-type="' . $attrs['type'] . '"' : '') . '
      ' . (isset($attrs['title']) && $attrs['title'] ? 'data-title="' . $attrs['title'] . '"' : '') . '>' .
    (!isset($attrs['tooltip']) || $attrs['tooltip'] == 'marker_tooltip' ? $text : '') . '
      <iframe width="100%" height="' . (isset($attrs['height']) ? $attrs['height'] : 276) . '" 
      src="https://maps.google.com/maps?' . http_build_query($data) . '"
        frameborder="0" scrolling="no" marginheight="0" marginwidth="0">
      </iframe>
    </div>
  </div>';
  return $text;
}

function shortcode_bootstrap_map_tip($format, $long) {
  $output = [];
  $output[] = '<p><strong>Google Map:</strong><br/>[gmap height = 300 zoom = 5 lat = "40.3456" lng = "-56.8795" title = "New York"]Tooltip text for Marker[/gmap]</br>';
  return implode(' ', $output);
}

function shortcode_bootstrap_map_settings($attrs, $text) {
  $form['title'] = [
    '#type' => 'textfield',
    '#title' => t('Title'),
    '#default_value' => isset($attrs['title']) ? $attrs['title'] : '',
    '#attributes' => ['class' => ['form-control']],
    '#prefix' => '<div class = "row"><div class = "col-sm-9">',
  ];
  $types = [
    '' => t('Default'),
    'terrain' => t('Terrain'),
    'satellite' => t('Satellite'),
  ];
  $form['type'] = [
    '#type' => 'select',
    '#title' => t('Type'),
    '#options' => $types,
    '#default_value' => isset($attrs['type']) ? $attrs['type'] : '',
    '#attributes' => ['class' => ['form-control']],
    '#prefix' => '</div><div class = "col-sm-3">',
    '#suffix' => '</div></div>',
  ];
  $form['lat'] = [
    '#type' => 'textfield',
    '#title' => t('Latitude'),
    '#default_value' => isset($attrs['lat']) ? $attrs['lat'] : '',
    '#attributes' => ['class' => ['form-control']],
    '#prefix' => '<div class = "row"><div class = "col-sm-3">',
  ];
  $form['lng'] = [
    '#type' => 'textfield',
    '#title' => t('Longitude'),
    '#default_value' => isset($attrs['lng']) ? $attrs['lng'] : '',
    '#attributes' => ['class' => ['form-control']],
    '#prefix' => '</div><div class = "col-sm-3">',
  ];
  $form['zoom'] = [
    '#type' => 'textfield',
    '#title' => t('Zoom'),
    '#default_value' => isset($attrs['zoom']) ? $attrs['zoom'] : '',
    '#attributes' => ['class' => ['form-control']],
    '#prefix' => '</div><div class = "col-sm-3">',
  ];
  $form['height'] = [
    '#type' => 'textfield',
    '#title' => t('Height'),
    '#default_value' => isset($attrs['height']) ? $attrs['height'] : '',
    '#attributes' => ['class' => ['form-control']],
    '#prefix' => '</div><div class = "col-sm-3">',
    '#suffix' => '</div></div>',
  ];
  $types = [
    'marker_tooltip' => t('Marker Toolip'),
    'map_overlay' => t('Map Overlay Box'),
  ];
  $form['tooltip'] = [
    '#type' => 'select',
    '#title' => t('Append inner content to:'),
    '#options' => $types,
    '#default_value' => isset($attrs['tooltip']) ? $attrs['tooltip'] : 'marker_tooltip',
    '#attributes' => ['class' => ['form-control']],
    '#prefix' => '<div class = "row"><div class = "col-sm-6">',
    '#suffix' => '</div></div>',
  ];
  return $form;
}

function shortcode_bootstrap_tabs($attrs, $text) {
  global $tab_content;
  $attrs['class'] = 'tabs ' . (isset($attrs['class']) ? $attrs['class'] : '') . (isset($attrs['type']) ? $attrs['type'] : '');
  $text = '<div ' . _shortcode_bootstrap_attributes($attrs) . '>
    <ul class = "nav nav-tabs">' .
    $text .
    '</ul>
    <div class = "tab-content">' .
    $tab_content .
    '</div>
    <div class="clearfix"></div>
    </div>';
  $tab_content = '';
  return $text;
}

function shortcode_bootstrap_tabs_tip($format, $long) {
  $output = [];
  $output[] = '<p><strong>Tabs:</strong><br/>[tabs]<br/>[tab title = "title" icon = "fa fa-user"]Text[/tab]<br>[/tabs]</br>';
  $output[] = 'Available variables: <strong>title</strong> - tabs of the title, <strong>icon</strong> - font class of the icon.</p>';
  return implode(' ', $output);
}

function shortcode_bootstrap_tabs_settings($attrs, $text) {
  $types = [
    '' => t('Horizontal'),
    'tabs-left' => t('Vertical Left'),
    'tabs-right' => t('Vertical Right'),
  ];
  $form['type'] = [
    '#type' => 'select',
    '#title' => t('Type'),
    '#options' => $types,
    '#default_value' => isset($attrs['type']) ? $attrs['type'] : '',
    '#attributes' => ['class' => ['form-control']],
    '#prefix' => '<div class = "row"><div class = "col-sm-4">',
    '#suffix' => '</div></div>',
  ];
  return $form;
}

function shortcode_bootstrap_tab($attrs, $text) {
  global $tab_counter;
  global $tab_content;
  $tab_counter++;
  $attrs['class'] = isset($attrs['class']) ? $attrs['class'] : '';
  $attrs['class'] .= $tab_content == '' ? ' active' : '';
  $class = shortcode_add_class($attrs['class']);
  $icon = isset($attrs['icon']) ? '<i class = "' . $attrs['icon'] . '"></i> ' : '';
  $output = '<li ' . _shortcode_bootstrap_attributes($attrs) . '><a href = "#tab-' . $tab_counter . '" data-toggle = "tab">' . $icon . (isset($attrs['title']) ? $attrs['title'] : '') . '</a></li>';

  if ($tab_content == '') {
    $class .= ' in';
  }
  $tab_content .= '<div class="tab-pane fade ' . $class . '" id="tab-' . $tab_counter . '">' . $text . '</div>';

  return $output;
}

function shortcode_bootstrap_tab_settings($attrs, $text) {
  $form['title'] = [
    '#type' => 'textfield',
    '#title' => t('Title'),
    '#default_value' => isset($attrs['title']) ? $attrs['title'] : '',
    '#attributes' => ['class' => ['form-control']],
    '#prefix' => '<div class = "row"><div class = "col-sm-9">',
  ];
  $form['icon'] = [
    '#title' => t('Icon'),
    '#type' => 'textfield',
    '#autocomplete_path' => 'admin/ajax/visualshortcodes/icons_autocomplete/all',
    '#default_value' => isset($attrs['icon']) ? $attrs['icon'] : '',
    '#attributes' => ['class' => ['form-control']],
    '#prefix' => '</div><div class = "col-sm-3">',
    '#suffix' => '</div></div>',
  ];
  return $form;
}

function shortcode_bootstrap_hr($attrs, $text) {
  $attrs['class'] = (isset($attrs['class']) ? $attrs['class'] : '') . (isset($attrs['type']) ? ' ' . $attrs['type'] : '');
  $text = '<hr ' . _shortcode_bootstrap_attributes($attrs) . '></hr>';
  return $text;
}

function shortcode_bootstrap_hr_tip($format, $long) {
  $output = [];
  $output[] = '<p><strong>Horizontal Rules:</strong><br/>[hr][/hr]</p>';
  return implode(' ', $output);
}

function shortcode_bootstrap_hr_settings($attrs, $text) {
  $types = [
    '' => t('Default'),
    'no-line' => t('No Line'),
    'shadow' => t('Shadow'),
    'dotted' => t('Dotted'),
    'dashed' => t('Dashed'),
    'double' => t('Double'),
  ];
  $form['type'] = [
    '#type' => 'select',
    '#title' => t('Type'),
    '#options' => $types,
    '#default_value' => isset($attrs['type']) ? $attrs['type'] : '',
    '#attributes' => ['class' => ['form-control']],
  ];
  return $form;
}

function shortcode_bootstrap_title($attrs, $text) {
  $attrs['class'] = isset($attrs['class']) ? ' ' . $attrs['class'] : '';
  $attrs['class'] .= isset($attrs['underline']) && $attrs['underline'] && (!isset($attrs['type']) || $attrs['type'] != 'page') ? ' title-box' : '';
  $attrs['class'] .= isset($attrs['title_align']) && $attrs['title_align'] ? ' ' . $attrs['title_align'] : '';
  $tag = isset($attrs['type']) && $attrs['type'] ? $attrs['type'] : 'h3';
  $tag = $tag == 'page' ? 'h1' : $tag;
  $text = trim($text) ? $text : (isset($attrs['title']) ? $attrs['title'] : '');
  $text = '<' . $tag . ' class = "title">' . $text . '</' . $tag . '>';
  if (isset($attrs['type']) && $attrs['type'] == 'page') {
    $attrs['class'] .= ' page-header';
    $output = '<header ' . _shortcode_bootstrap_attributes($attrs) . '><div class = "container">' . $text . '</div></header>';
  }
  else {
    $output = '<div ' . _shortcode_bootstrap_attributes($attrs) . '>' . $text . '</div>';
  }
  return $output;
}

function shortcode_bootstrap_title_tip($format, $long) {
  $output = [];
  $output[] = '<p><strong>Title:</strong><br/>[title type = "h3" underline = "1"][/title]</p>';
  return implode(' ', $output);
}

function shortcode_bootstrap_title_settings($attrs, $text) {
  $form['title'] = [
    '#type' => 'textfield',
    '#title' => t('Title'),
    '#default_value' => $text ? $text : (isset($attrs['title']) ? $attrs['title'] : ''),
    '#attributes' => ['class' => ['form-control']],
  ];
  $types = [
    'h1' => 'H1',
    'h2' => 'H2',
    'h3' => 'H3',
    'h4' => 'H4',
    'h5' => 'H5',
    'h6' => 'H6',
    'page' => t('Page Header'),
  ];
  $form['type'] = [
    '#type' => 'select',
    '#title' => t('Type'),
    '#options' => $types,
    '#default_value' => isset($attrs['type']) ? $attrs['type'] : 'h2',
    '#attributes' => ['class' => ['form-control']],
  ];
  $form['underline'] = [
    '#type' => 'checkbox',
    '#title' => t('Underline'),
    '#default_value' => isset($attrs['underline']) ? $attrs['underline'] : 1,
  ];
  $aligns = [
    '' => t('Left'),
    'text-center' => t('Center'),
    'text-right' => t('Right'),
  ];
  $form['title_align'] = [
    '#type' => 'select',
    '#title' => t('Align'),
    '#options' => $aligns,
    '#default_value' => isset($attrs['title_align']) ? $attrs['title_align'] : '',
    '#attributes' => ['class' => ['form-control']],
  ];
  return $form;
}

function shortcode_bootstrap_sitemap($attrs, $text) {
  if (isset($attrs['machine_name']) && $attrs['machine_name']) {
    $menu_tree = menu_tree_all_data($attrs['machine_name']);
    if ($attrs_output = _shortcode_bootstrap_attributes($attrs)) {
      return '<div ' . $attrs_output . '>' . _shortcode_bootstrap_sitemap($menu_tree, 'sitemap') . '</div>';
    }
    return _shortcode_bootstrap_sitemap($menu_tree, 'sitemap');
  }
  return '';
}

function _shortcode_bootstrap_sitemap($items, $class = '') {
  $output = '<ul' . ($class ? ' class = "' . $class . '"' : '') . '>';
  foreach ($items as $item) {
    if ($item['link']['hidden'] <> 1) {
      $output .= '<li>' . l(t($item['link']['link_title']), $item['link']['link_path']);
      if (!empty($item['below'])) {
        $output .= _shortcode_bootstrap_sitemap($item['below']);
      }
      $output .= '</li>';
    }
  }
  return $output . '</ul>';
}

function shortcode_bootstrap_sitemap_tip($format, $long) {
  $output = [];
  $output[] = '<p><strong>SiteMap:</strong><br/>[sitemap machine_name = "main-menu"][/sitemap]</br>';
  return implode(' ', $output);
}

function shortcode_bootstrap_html($attrs, $text) {
  // Made a little hack for tables which can't be controled because rendered some WYSIWYG editor, and also list styles
  //  $text = str_replace(array('<table', '<ul>', '<ol>', '|LS|', '|RS|', '|LF|', '|RF|'), array('<table class = "table table-bordered table-striped"', '<ul class = "list">', '<ol class = "list">', '[', ']', '{', '}'), $text);
  if (isset($attrs['format'])) {
    $text = check_markup($text, $attrs['format']);
  }
  $attrs_output = _shortcode_bootstrap_attributes($attrs);
  if ($attrs_output) {
    return '<div ' . $attrs_output . '>' . $text . '</div>';
  }
  return $text;
}

function shortcode_bootstrap_styledcontainer($attrs, $text) {
  $attrs['class'] = isset($attrs['class']) ? ' ' . $attrs['class'] : '';
  $attrs['class'] .= isset($attrs['type']) ? ' ' . $attrs['type'] : '';
  $attrs['class'] .= isset($attrs['border']) ? ' ' . $attrs['border'] : '';
  $attrs['class'] .= isset($attrs['shadow']) ? ' ' . $attrs['shadow'] : '';
  if (isset($attrs['degree']) && $attrs['degree']) {
    $wrap_attrs = [];
    foreach (['-webkit-', '-moz-', '-ms', '-o-', ''] as $suffix) {
      $wrap_attrs['style'] = (isset($attrs['styles']) ? $attrs['styles'] . ' ' : ' ') . $suffix . 'transform: rotate(' . $attrs['degree'] . 'deg);';
    }
  }
  $overlay = isset($attrs['overlay']) && $attrs['overlay'] ? '<div class="overlay"></div>' : '';
  if (isset($attrs['background_image']) && $attrs['background_image'] && in_array($attrs['background'], [
      'fixed',
      'static',
      'paralax',
      'blur',
    ])) {
    $attrs['class'] .= ' full-width-box';
    if (isset($attrs['background']) && $attrs['background'] == 'static') {
      $attrs['style_background_image'] = $attrs['background_image'];
    }
    if (isset($attrs['background']) && $attrs['background'] == 'fixed') {
      $inner_attrs = [
        'style_background_image' => $attrs['background_image'],
      ];
      $text = '<div class="fwb-bg fwb-' . $attrs['background'] . '" ' . _shortcode_bootstrap_attributes($inner_attrs) . '>' . $overlay . '</div>' . $text;
    }
    if (isset($attrs['background']) && $attrs['background'] == 'paralax') {
      $inner_attrs = [
        'data-speed' => isset($attrs['stellar_background_ratio']) ? $attrs['stellar_background_ratio'] : '2',
        'style_background_image' => $attrs['background_image'],
        "data-parallax" => "scroll",
        "data-image-src" => file_create_url(file_load($attrs['background_image'])->uri),
      ];
      $text = '<div class="fwb-bg fwb-' . $attrs['background'] . '" ' . _shortcode_bootstrap_attributes($inner_attrs) . '>' . $overlay . '</div>' . $text;
      if (!empty(libraries_get_path('paralax'))) {
        drupal_add_js(libraries_get_path('paralax') . '/paralax.js');
      }
      else {
        drupal_add_js(shortcode_bootstrap_cdn('paralax'), 'external');
      }
    }
    if (isset($attrs['background']) && $attrs['background'] == 'blur') {
      $inner_attrs = [
        'data-blur-amount' => isset($attrs['blur_amount']) ? $attrs['blur_amount'] : '2',
        'data-blur-image' => file_create_url(file_load($attrs['background_image'])->uri),
      ];
      $text = '<div class="fwb-bg fwb-' . $attrs['background'] . '" ' . _shortcode_bootstrap_attributes($inner_attrs) . '>' . $overlay . '</div>' . $text;
      if (!empty(libraries_get_path('pixastic'))) {
        drupal_add_js(libraries_get_path('pixastic') . '/pixastic.all.js');
      }
      else {
        drupal_add_js(shortcode_bootstrap_cdn('pixastic'), 'external');
      }
    }
  }
  if (isset($attrs['background']) && $attrs['background'] == 'video' && isset($attrs['video']) && $attrs['video']) {
    static $video_id = 999;
    $attrs['class'] = 'full-width-box';
    $attrs['data-stellar-background-ratio'] = isset($attrs['stellar_background_ratio']) ? $attrs['stellar_background_ratio'] : '0.5';
    $attrs['id'] = 'wrap-' . ++$video_id;
    $text = '<div id="' . $attrs['id'] . '" class="player" data-property="{videoURL: \'' . $attrs['video'] . '\', containment:\'#' . $attrs['id'] . '\', autoPlay:true, showControls:true, loop:true, mute:true, startAt:0, opacity:1, addRaster:false}"></div>' . $overlay . $text;

    if (!empty(libraries_get_path('jquery.mb.YTPlayer'))) {
      drupal_add_js(libraries_get_path('jquery.mb.YTPlayer') . '/dist/jquery.mb.YTPlayer.js');
      drupal_add_css(libraries_get_path('jquery.mb.YTPlayer') . '/dist/css/jquery.mb.YTPlayer.min.css');
    }
    else {
      drupal_add_js(shortcode_bootstrap_cdn('jquery.mb.YTPlayer')['js'], 'external');
      drupal_add_css(shortcode_bootstrap_cdn('jquery.mb.YTPlayer')['css'], 'external');
    }
  }
  $output = '<div ' . _shortcode_bootstrap_attributes($attrs) . '>' . $text . '</div>';
  if (isset($wrap_attrs)) {
    $output = '<div ' . _shortcode_bootstrap_attributes($wrap_attrs) . '>' . $output . '</div>';
  }
  return $output;
}

function shortcode_bootstrap_styledcontainer_settings($attrs, $text) {
  $types = [
    'content-block' => t('Container'),
    'frame-padding' => t('Frame'),
    '' => t(' - No Paddings - '),
  ];
  $form['type'] = [
    '#type' => 'select',
    '#title' => t('Padding type'),
    '#options' => $types,
    '#default_value' => isset($attrs['type']) ? $attrs['type'] : 'content-block',
    '#attributes' => ['class' => ['form-control']],
    '#prefix' => '<div class = "row"><div class = "col-sm-6">',
  ];

  $border = [
    '' => t(' - None - '),
    'frame' => t('Border'),
    'frame border-radius' => t('Border with Radius'),
  ];
  $form['border'] = [
    '#type' => 'select',
    '#title' => t('Border'),
    '#options' => $border,
    '#default_value' => isset($attrs['border']) ? $attrs['border'] : '',
    '#attributes' => ['class' => ['form-control']],
    '#prefix' => '</div><div class = "col-sm-6">',
    '#suffix' => '</div></div>',
  ];

  $shadows = [
    '' => t(' - None - '),
    'frame-shadow' => t('Shadow'),
    'frame-shadow-lifted' => t('Shadow Lifted'),
    'frame-shadow-raised' => t('Shadow Raised'),
    'frame-shadow-curved' => t('Shadow Curved'),
  ];
  $form['shadow'] = [
    '#type' => 'select',
    '#title' => t('Shadow'),
    '#options' => $shadows,
    '#default_value' => isset($attrs['shadow']) ? $attrs['shadow'] : '',
    '#attributes' => ['class' => ['form-control']],
    '#prefix' => '<div class = "row"><div class = "col-sm-6">',
  ];
  $form['degree'] = [
    '#type' => 'textfield',
    '#title' => t('Rotate Degree'),
    '#default_value' => isset($attrs['degree']) ? $attrs['degree'] : '',
    '#description' => t('Any degree value, for example: -90'),
    '#attributes' => ['class' => ['form-control']],
    '#prefix' => '</div><div class = "col-sm-6">',
    '#suffix' => '</div></div>',
  ];
  $bgs = [
    '' => t(' - None - '),
    'static' => t('Static Image'),
    'fixed' => t('Fixed'),
    'paralax' => t('Parallax'),
    'blur' => t('Blurred Image'),
    'video' => t('Video'),
  ];
  $form['background'] = [
    '#type' => 'select',
    '#title' => t('Advanced Background'),
    '#options' => $bgs,
    '#default_value' => isset($attrs['background']) ? $attrs['background'] : '',
    '#attributes' => ['class' => ['form-control background-select']],
  ];
  $form['overlay'] = [
    '#type' => 'checkbox',
    '#title' => t('Overlay'),
    '#default_value' => isset($attrs['overlay']) ? $attrs['overlay'] : '',
    '#states' => [
      'visible' => [
        '.background-select, abcd' => ['!value' => ''],
        '.background-select, abc' => ['!value' => 'static'],
      ],
    ],
  ];
  $form['video'] = [
    '#type' => 'textfield',
    '#title' => t('Video URL'),
    '#default_value' => isset($attrs['video']) ? $attrs['video'] : '',
    '#states' => [
      'visible' => [
        '.background-select' => ['value' => 'video'],
      ],
    ],
    '#attributes' => ['class' => ['form-control']],
  ];
  $filename = isset($attrs['background_image']) && !empty($attrs['background_image']) ? file_load($attrs['background_image'])->uri : '';
  $image = $filename ? theme('image_style', [
    'style_name' => 'media_thumbnail',
    'path' => $filename,
  ]) : '';
  $form['background_image'] = [
    '#type' => 'textfield',
    '#title' => t('Image'),
    '#default_value' => isset($attrs['background_image']) ? $attrs['background_image'] : '',
    '#attributes' => ['class' => ['image-media-upload hidden']],
    '#field_suffix' => '<div class = "preview-image">' . $image . '</div><a href = "#" class = "media-upload button">' . t('Upload Image') . '</a><a href = "#" class = "media-remove button">' . t('Remove Image') . '</a>',
    '#states' => [
      'visible' => [
        '.background-select, abc' => ['!value' => ''],
        '.background-select, abcd' => ['!value' => 'video'],
      ],
    ],
    '#suffix' => '<div class = "clearfix"></div>',
  ];
  $form['stellar_background_ratio'] = [
    '#type' => 'textfield',
    '#title' => t('Stellar ratio'),
    '#default_value' => isset($attrs['stellar_background_ratio']) ? $attrs['stellar_background_ratio'] : '',
    '#attributes' => ['class' => ['form-control']],
    '#states' => [
      'visible' => [
        '.background-select, ab' => ['!value' => ''],
        '.background-select, abc' => ['!value' => 'static'],
        '.background-select, abcd' => ['!value' => 'fixed'],
        '.background-select, abcde' => ['!value' => 'blur'],
      ],
    ],
    '#description' => t('Default value: 0.5'),
  ];
  $form['blur_amount'] = [
    '#type' => 'textfield',
    '#title' => t('Blur Amount'),
    '#default_value' => isset($attrs['blur_amount']) ? $attrs['blur_amount'] : '',
    '#states' => [
      'visible' => [
        '.background-select' => ['value' => 'blur'],
      ],
    ],
    '#description' => t('Default value: 2'),
  ];
  return $form;
}

function shortcode_bootstrap_icon($attrs, $text) {
  $attrs['class'] = isset($attrs['shadow']) ? ' ' . $attrs['shadow'] : '';
  $text = isset($attrs['title']) && $attrs['title'] ? $attrs['title'] : '';
  $attrs['link'] = isset($attrs['link']) ? $attrs['link'] : '#';
  $attrs['href'] = strpos($attrs['link'], '#') === FALSE ? url($attrs['link']) : $attrs['link'];

  drupal_add_css(drupal_get_path('module', 'shortcode_bootstrap') . '/css/social-icons.css');

  if ($attrs['type'] == 'fontawesome') {
    if (!isset($attrs['style_color'])) {
      $attrs['style_color'] = '#f89406';
    }
    $attrs['class'] = 'icon icon-' . $attrs['fontawesome_size'] . (isset($attrs['class']) ? ' ' . $attrs['class'] : '');
    $text = '<i class = "' . $attrs['fontawesome_icon'] . '"></i>' . $text;
    return '<a ' . _shortcode_bootstrap_attributes($attrs) . '>' . $text . '</a>';
  }
  elseif ($attrs['type'] == 'livicon') {
    $attrs['class'] .= 'livicon block';
    $attrs['class'] .= isset($attrs['livicon_shadow']) && $attrs['livicon_shadow'] ? ' shadowed' : '';
    $text = '<a ' . _shortcode_bootstrap_attributes($attrs) . ' data-n="' . $attrs['livicon'] . '" data-s="' . $attrs['livicon_size'] . '"
    ' . (isset($attrs['color_type']) && $attrs['color_type'] && isset($attrs['style_color']) && $attrs['style_color'] ? 'data-c="#' . trim($attrs['style_color'], '#') . '"' : '') .
      (isset($attrs['livicon_type']) && $attrs['livicon_type'] == 'static' ? ' data-a="0"' : '') .
      (!isset($attrs['livicon_hover']) || !$attrs['livicon_hover'] ? ' data-hc="0"' : '') .
      (isset($attrs['livicon_type']) && $attrs['livicon_type'] == 'click_animation' ? ' data-et="click"' : '') .
      (isset($attrs['livicon_type']) && $attrs['livicon_type'] == 'click_loop' ? ' data-et="click" data-l = "1"' : '') .
      (isset($attrs['livicon_parent_trigger']) && $attrs['livicon_parent_trigger'] ? '' : ' data-op="0"') .
      '></a>' . $text;
    unset($attrs['style_color']);
    if (!empty(libraries_get_path('raphael'))) {
      drupal_add_js(libraries_get_path('raphael') . '/raphael.min.js');
    }
    else {
      drupal_add_js(shortcode_bootstrap_cdn('raphael'), 'external');
    }
    drupal_add_js(drupal_get_path('module', 'shortcode_bootstrap') . '/js/livicons.js');

    return $text;
  }
}

function shortcode_bootstrap_icon_settings($attrs, $text) {
  $form['fontawesome'] = [
    '#type' => 'container',
    '#states' => [
      'visible' => [
        '.icon-type-select' => ['value' => 'fontawesome'],
      ],
    ],
  ];
  $form['fontawesome']['fontawesome_icon'] = [
    '#title' => t('FontAwesome Icon'),
    '#type' => 'textfield',
    '#autocomplete_path' => 'admin/ajax/visualshortcodes/icons_autocomplete/all',
    '#default_value' => isset($attrs['fontawesome_icon']) ? $attrs['fontawesome_icon'] : '',
    '#attributes' => ['class' => ['form-control']],
    '#prefix' => '<div class = "row"><div class = "col-sm-6">',
  ];
  $sizes = [
    '24' => '24px',
    '32' => '32px',
    '40' => '40px',
    '60' => '60px',
    '100' => '100px',
  ];
  $form['fontawesome']['fontawesome_size'] = [
    '#title' => t('Font Size'),
    '#type' => 'select',
    '#options' => $sizes,
    '#default_value' => isset($attrs['fontawesome_size']) ? $attrs['fontawesome_size'] : '',
    '#attributes' => ['class' => ['form-control']],
    '#prefix' => '</div><div class = "col-sm-6">',
    '#suffix' => '</div></div>',
  ];

  $form['livicon'] = [
    '#type' => 'container',
    '#states' => [
      'visible' => [
        '.icon-type-select' => ['value' => 'livicon'],
      ],
    ],
  ];
  $form['livicon']['livicon'] = [
    '#title' => t('Livicon'),
    '#type' => 'textfield',
    '#autocomplete_path' => 'admin/ajax/shortcode_boostrap/livicons_autocomplete',
    '#default_value' => isset($attrs['livicon']) ? $attrs['livicon'] : '',
    '#attributes' => ['class' => ['form-control']],
    '#prefix' => '<div class = "row"><div class = "col-sm-3">',
  ];
  $sizes = [
    '16' => '16px',
    '24' => '24px',
    '32' => '32px',
    '48' => '48px',
    '56' => '56px',
    '64' => '64px',
    '96' => '96px',
  ];
  $form['livicon']['livicon_size'] = [
    '#title' => t('Font Size'),
    '#type' => 'select',
    '#options' => $sizes,
    '#default_value' => isset($attrs['livicon_size']) ? $attrs['livicon_size'] : '',
    '#attributes' => ['class' => ['form-control']],
    '#prefix' => '</div><div class = "col-sm-3">',
  ];
  $types = [
    '' => t('Animate on hover'),
    'static' => t('Static'),
    'click_animation' => t('Animate on click'),
    'click_loop' => t('Click Start/Stop'),
  ];
  $form['livicon']['livicon_type'] = [
    '#title' => t('Type'),
    '#type' => 'select',
    '#options' => $types,
    '#default_value' => isset($attrs['livicon_type']) ? $attrs['livicon_type'] : '',
    '#attributes' => ['class' => ['form-control']],
    '#prefix' => '</div><div class = "col-sm-3">',
  ];
  $form['livicon']['livicon_hover'] = [
    '#title' => t('Hover color effect'),
    '#type' => 'checkbox',
    '#default_value' => isset($attrs['livicon_hover']) ? $attrs['livicon_hover'] : '',
    '#prefix' => '</div><div class = "col-sm-3">',
  ];
  $form['livicon']['livicon_parent_trigger'] = [
    '#title' => t('Parent hover'),
    '#type' => 'checkbox',
    '#default_value' => isset($attrs['livicon_parent_trigger']) ? $attrs['livicon_parent_trigger'] : '',
  ];
  $form['livicon']['livicon_shadow'] = [
    '#title' => t('Shadow'),
    '#type' => 'checkbox',
    '#default_value' => isset($attrs['livicon_shadow']) ? $attrs['livicon_shadow'] : '',
    '#suffix' => '</div></div>',
  ];

  $types = ['fontawesome' => t('FontAwesome'), 'livicon' => t('LivIcon')];
  $form['type'] = [
    '#type' => 'select',
    '#title' => t('Icon Type'),
    '#options' => $types,
    '#default_value' => isset($attrs['type']) ? $attrs['type'] : 'fontawesome',
    '#attributes' => ['class' => ['form-control icon-type-select']],
    '#prefix' => '<div class = "row"><div class = "col-sm-6">',
  ];
  $form['title'] = [
    '#type' => 'textfield',
    '#title' => t('Title'),
    '#default_value' => isset($attrs['title']) ? $attrs['title'] : '',
    '#attributes' => ['class' => ['form-control']],
    '#prefix' => '</div><div class = "col-sm-6">',
    '#suffix' => '</div></div>',
  ];
  $form['color_type'] = [
    '#title' => t('Custom Color'),
    '#type' => 'checkbox',
    '#default_value' => isset($attrs['color_type']) ? $attrs['color_type'] : '',
    '#attributes' => ['class' => ['color-type-select']],
    '#prefix' => '<div class = "row"><div class = "col-sm-6">',
  ];
  $form['style_color'] = [
    '#type' => 'textfield',
    '#title' => t('Color'),
    '#default_value' => isset($attrs['style_color']) ? $attrs['style_color'] : '',
    '#states' => [
      'visible' => [
        '.color-type-select' => ['checked' => TRUE],
      ],
    ],
    '#attributes' => ['class' => ['form-control colorpicker-enable']],
  ];
  $form['link'] = [
    '#type' => 'textfield',
    '#title' => t('Link'),
    '#default_value' => isset($attrs['link']) ? $attrs['link'] : '',
    '#attributes' => ['class' => ['form-control']],
    '#prefix' => '</div><div class = "col-sm-6">',
    '#suffix' => '</div></div>',
  ];
  return $form;
}

function shortcode_bootstrap_textrotation($attrs, $text) {
  $attrs['class'] = 'word-rotate ' . (isset($attrs['class']) ? ' ' . $attrs['class'] : '');
  $words = '';
  foreach ($attrs as $name => $value) {
    if (strpos($name, 'word_') === 0) {
      $words .= '<span>' . $value . '</span>';
    }
  }
  $attrs['tag'] = isset($attrs['tag']) ? $attrs['tag'] : 'div';
  $attrs['prefix'] = isset($attrs['prefix']) ? $attrs['prefix'] : '';
  $attrs['suffix'] = isset($attrs['title']) ? $attrs['title'] : '';
  return '<' . $attrs['tag'] . '>' .
    $attrs['prefix'] . '
    <span ' . _shortcode_bootstrap_attributes($attrs) . ' >
      <span class = "words-box">' . $words . '</span>
    </span>' .
    $attrs['suffix'] . '
  </' . $attrs['tag'] . '>';
}

function shortcode_bootstrap_textrotation_settings($attrs, $text, $form, &$form_state) {
  $form['prefix'] = [
    '#type' => 'textfield',
    '#title' => t('Prefix text'),
    '#default_value' => isset($attrs['prefix']) ? $attrs['prefix'] : '',
    '#attributes' => ['class' => ['form-control']],
  ];
  $form['title'] = [
    '#type' => 'textfield',
    '#title' => t('Suffix text'),
    '#default_value' => $text ? $text : (isset($attrs['title']) ? $attrs['title'] : ''),
    '#attributes' => ['class' => ['form-control']],
  ];
  $types = [
    'div' => 'Div',
    'p' => 'P',
    'strong' => t('Strong'),
    'span' => 'Span',
    'h1' => 'H1',
    'h2' => 'H2',
    'h3' => 'H3',
    'h4' => 'H4',
    'h5' => 'H5',
    'h6' => 'H6',
  ];
  $form['tag'] = [
    '#type' => 'select',
    '#title' => t('Tag Type'),
    '#options' => $types,
    '#default_value' => isset($attrs['tag']) ? $attrs['tag'] : 'div',
    '#attributes' => ['class' => ['form-control']],
    '#prefix' => '<div class = "row"><div class = "col-sm-6">',
    '#suffix' => '</div></div>',
  ];
  $form['words'] = [
    '#type' => 'container',
    '#attributes' => ['id' => ['visualshortcodes_textrotation_words']],
  ];
  // If AJAX was submited
  if (isset($form_state['values']['add_new'])) {
    $attrs = $form_state['values'];
    foreach ($form_state['values'] as $name => $value) {
      if (strpos($name, 'word_') === 0) {
        $i = str_replace('word_', '', $name);
        $form['words']['word_' . $i] = shortcode_bootstrap_textrotation_item($attrs, $i);
      }
    }
    // Add new row
    $form['words']['word_' . ++$i] = shortcode_bootstrap_textrotation_item($attrs, $i);
  }
  // Default attrs
  else {
    $attrs['word_1'] = isset($attrs['word_1']) ? $attrs['word_1'] : '';
    foreach ($attrs as $name => $value) {
      if (strpos($name, 'word_') === 0) {
        $i = str_replace('word_', '', $name);
        $form['words']['word_' . $i] = shortcode_bootstrap_textrotation_item($attrs, $i);
      }
    }
  }
  $form['add_new'] = [
    '#type' => 'submit',
    '#value' => t('Add new item'),
    '#submit' => ['shortcode_bootstrap_ajax_rebuild'],
    '#ajax' => [
      'callback' => 'shortcode_bootstrap_textrotation_ajax_callback',
      'wrapper' => 'visualshortcodes_textrotation_words',
      'effect' => 'fade',
      'method' => 'replace',
    ],
  ];
  return $form;
}

function shortcode_bootstrap_textrotation_item($attrs, $i) {
  return [
    '#title' => t('Phrase ' . $i),
    '#type' => 'textfield',
    '#default_value' => isset($attrs['word_' . $i]) ? $attrs['word_' . $i] : '',
    '#attributes' => ['class' => ['form-control']],
    '#prefix' => '<div class = "row"><div class = "col-sm-6">',
    '#suffix' => '</div></div>',
  ];
}

function shortcode_bootstrap_ajax_rebuild($form, &$form_state) {
  $form_state['rebuild'] = TRUE;
}

function shortcode_bootstrap_textrotation_ajax_callback($form, $form_state) {
  return $form['shortcode']['settings']['words'];
}

function shortcode_bootstrap_chart($attrs, $text) {
  $table = _convert_text_to_table($attrs, $text);
  $output = theme('table', [
    'rows' => $table,
    'caption' => $attrs['title'],
    'attributes' => [
      'class' => ['chart'],
      'id' => substr(str_shuffle("abcdefghijklmnopqrstuvwxyz"), 0, 5),
      'data-type' => $attrs['type'],
      'data-stacked' => $attrs['chart_type_stacked'],
      'data-legend_position' => $attrs['chart_legend_position'],
      'data-width' => $attrs['chart_width'],
      'data-height' => $attrs['chart_height'],
      'data-3d' => $attrs['chart_3d'],
      'data-pieHole' => $attrs["chart_piehole"],
    ]
  ]);
  drupal_add_js('https://www.gstatic.com/charts/loader.js', 'external');
  drupal_add_js(drupal_get_path('module', 'shortcode_bootstrap') . '/js/shortcode_bootstrap.chart.js');
  return $output;
}

function shortcode_bootstrap_chart_settings($attrs, $text, $form, &$form_state) {
  $form = _data_table_form($attrs, $text);
  $form['title'] = [
    '#type' => 'textfield',
    '#title' => t('Title'),
    '#default_value' => isset($attrs['title']) ? $attrs['title'] : '',
  ];
  $form['type'] = array(
    '#type' => 'select',
    '#title' => t('Chart type'),
    '#options' => array(
      'BarChart' => t('Bar Chart'),
      'LineChart' => t('Line Chart'),
      'PieChart' => t('Pie Chart'),
      'ColumnChart' => t('Column Chart'),
      'Histogram' => t('Histogram'),
      'Timeline' => t('Timeline'),
      'OrgChart' => t('Organization Chart'),
      'ScatterChart' => t('Scatter Chart'),
      'AreaChart' => t('Area Chart'),
      'SteppedAreaChart' => t('Stepped Area Chart'),
      'BubbleChart' => t('Bubble Chart'),
      'CandlestickChart' => t('Candlestick Chart'),
      'Calendar' => t('Calendar Chart'),
      'ComboChart' => t('Combo Chart'),
      'Gauge' => t('Gauge Charts'),
      'Sankey' => t('Sankey Diagram'),
      'WordTree' => t('Word Tree'),
      'Table' => t('Table'),
    ),
    '#description' => t('View example : <a href="https://google-developers.appspot.com/chart/interactive/docs/gallery">Google Chart gallery</a>'),
    '#default_value' => !empty($attrs['type']) ? $attrs['type'] : 'LineChart',
  );
  /*
  $form['chart_type_stacked'] = array(
    '#type' => 'radios',
    '#title' => t('Do you want Stack in Graph?'),
    '#options' => array(t('No'),t('Yes')),
    '#description' => t('This is applicable only for Bar and Column chart.'),
    '#default_value' => !empty($attrs['chart_type_stacked']) ? $attrs['chart_type_stacked'] : '',
    '#states' => [
      'visible' => [
        ['#edit-type' => ['value' => 'PieChart']],
        ['#edit-type' => ['value' => 'BarChart']],
        ['#edit-type' => ['value' => 'ColumnChart']],
      ],
    ],
  );*/
  $form['chart_legend_position'] = array(
    '#type' => 'select',
    '#title' => t('Chart Legend Position'),
    '#options' => array('left' => t('Left'),'right' => t('Right'),'top' => t('Top'),'bottom' => t('Bottom')),
    '#default_value' => !empty($attrs['chart_legend_position']) ? $attrs['chart_legend_position'] : '',
  );
  $form['chart_width'] = array(
    '#title' => t('Chart Width'),
    '#type' => 'textfield',
    '#size' => '60',
    '#default_value' => !empty($attrs['chart_width']) ? $attrs['chart_width'] : '',
  );
  $form['chart_height'] = array(
    '#title' => t('Chart Height'),
    '#type' => 'textfield',
    '#size' => '60',
    '#default_value' => !empty($attrs['chart_height']) ? $attrs['chart_height'] : '',
  );
  $form['chart_3d'] = [
    '#title' => t('Chart 3D'),
    '#type' => 'checkbox',
    '#default_value' => empty($attrs['chart_3d']) ? 0 : 1,
    '#states' => [
      'visible' => [
        ['#edit-type' => ['value' => 'PieChart']],
        ['#edit-type' => ['value' => 'BarChart']],
        ['#edit-type' => ['value' => 'ColumnChart']],
      ],
    ],
  ];
  $form['chart_piehole'] = [
    '#title' => t('Chart Pie hole'),
    '#type' => 'textfield',
    '#attributes' => [
      'type' => 'number',
      'min' => 0.1,
      'max' => 1,
    ],
    '#description' => t('Making a Donut Chart exemple : 0.5'),
    '#default_value' => !empty($attrs['chart_piehole']) ? $attrs['chart_piehole'] : '',
    '#states' => [
      'visible' => [
        '#edit-type' => ['value' => 'PieChart'],
      ],
    ],
  ];

  return $form;
}
function _data_table_form($attrs, $text){
  if (empty($text) && !empty($attrs['data'])) {
    $text = $attrs['data'];
  }
  $delimiters = [
    'TAB' => t('TAB'),
    ',' => t('Comma ,'),
    ';' => t('Semicolon ;'),
    '|' => t('Pipe |'),
    '+' => t('Plus +'),
    ':' => t('Colon :'),
  ];
  $form['paste_delimiter'] = [
    '#type' => 'select',
    '#title' => t('Column separator'),
    '#options' => $delimiters,
    '#description' => t('Data copied from Excel will use TAB.'),
    '#default_value' => !empty($attrs["paste_delimiter"]) ? $attrs["paste_delimiter"] : 'TAB',
  ];
  $form['text_data[value]'] = [
    '#type' => 'textarea',
    '#default_value' => !empty($text) ? str_replace("§", PHP_EOL, $text) : '',
    '#title' => t('Paste table data here:'),
  ];
  return $form;
}
function shortcode_bootstrap_table_settings($attrs, $text, $settings, $form_state) {
  $form = _data_table_form($attrs, $text);
  $form['classes'] = [
    '#title' => t('The class name of table'),
    '#type' => 'textfield',
    '#description' => t('Default: table table-bordered table-hover. Can add more class like table-striped table-dark table-sm table-borderless '),
    '#default_value' => !empty($attrs["classes"]) ? $attrs["classes"] : '',
  ];
  $form['pageSize'] = [
    '#type' => 'select',
    '#title' => t('Page Size'),
    '#options' => array_combine([10, 20, 50, 100, 200], [10, 20, 50, 100, 200]),
    '#description' => t('When set pagination property, initialize the page size'),
    '#default_value' => !empty($attrs["pageSize"]) ? $attrs["pageSize"] : 'TAB',
  ];
  return $form;
}
function _convert_text_to_table($attrs, $text){
  $col_delimiter = $attrs["paste_delimiter"];
  if ($col_delimiter == 'TAB') {
    $col_delimiter = "\t";
  }
  // Populate table with pasted values.
  $max_col_count = 0;
  $row_count = 0;
  $table = [];
  $brake_line = "§";
  foreach (["\r\n", "\n", "\r"] as $break) {
    if (strpos($text, $break) !== FALSE) {
      $brake_line = $break;
      break;
    }
  }
  $rows = explode($brake_line, $text);
  foreach ($rows as $row_id => $row) {
    // Explode the current row into columns:
    $cols = str_getcsv($row, $col_delimiter);
    $col_count = count($cols);
    if ($col_count > 0) {
      foreach ($cols as $col_id => $col) {
        $table[$row_count][$col_id] = $col;
      }
      $max_col_count = $col_count > $max_col_count ? $col_count : $max_col_count;
      $row_count++;
    }
  }
  return $table;
}
function shortcode_bootstrap_table($attrs, $text) {
  if (empty(trim($text)) && !empty($attrs['text_data[value'])) {
    $text = $attrs['text_data[value'];
  }
  if (!empty($text)) {
    $table = _convert_text_to_table($attrs, $text);
    $header = array_shift($table);
    $attributes = [
      //'data-toggle'=>"bootstrap-table",
      'data-toggle' => "table",
      'data-search' => "true",
      'data-trim-on-search' => "true",
      'data-sortable' => "true",
      'data-sort-stable' => "true",
      'data-exportTypes' => "['xml', 'csv', 'excel']",
      'data-show-export' => "true",
      'data-show-toggle' => "true",
      'data-show-pagination-switch' => "true",
      'data-show-fullscreen' => "true",
      'data-smart-display' => "true",
      'data-stickyHeader' => "true",
      'data-remember-order' => "true",
      'data-pagination' => "true",
      'data-page-size' => $attrs["pagesize"],
      'data-page-list' => "[10,20,50,100,200]",
      'data-classes' => $attrs["classes"],
    ];
    foreach ($header as $index => $cell_header) {
      $header[$index] = [
        'data' => $cell_header,
        'class' => 'sortable',
        'data-sortable' => "true",
      ];
    }
    $text = theme('table', [
      'rows' => $table,
      'header' => $header,
      'attributes' => $attributes,
    ]);

    if (!empty(libraries_get_path('bootstrap-table'))) {
      drupal_add_js(libraries_get_path('bootstrap-table') . '/dist/bootstrap-table-locale-all.js');
      drupal_add_js(libraries_get_path('bootstrap-table') . '/dist/extensions/export/bootstrap-table-export.js');
      drupal_add_css(libraries_get_path('bootstrap-table') . '/dist/bootstrap-table.min.css');
    }
    else {
      drupal_add_js(shortcode_bootstrap_cdn('bootstrap-table')['tableexport'], 'external');
      drupal_add_js(shortcode_bootstrap_cdn('bootstrap-table')['pdf'], 'external');
      drupal_add_js(shortcode_bootstrap_cdn('bootstrap-table')['autotable'], 'external');
      drupal_add_js(shortcode_bootstrap_cdn('bootstrap-table')['js'], 'external');
      drupal_add_css(shortcode_bootstrap_cdn('bootstrap-table')['css'], 'external');
      drupal_add_js(shortcode_bootstrap_cdn('bootstrap-table')['export'], 'external');
    }
  }
  return $text;
}

function _shortcode_bootstrap_render_block($module, $delta) {
  $block = block_load($module, $delta);
  return isset($block->theme) ? _block_get_renderable_array(_block_render_blocks([$block])) : [];
}
